
-- RANDOM FUNCTIONS USED IN THE PLUGIN


function Turbine.UI.Control.SetSearchID(Sender,ID)
	if ID == nil then
		Sender["SearchID"] = nil;
		return;
	end
	Sender["SearchID"] = ID;
end


function Turbine.UI.Control.GetSearchID(Sender)
	if Sender == nil or Sender["SearchID"] == nil then return "" end
	return Sender["SearchID"];
end


function Turbine.UI.Control.SetHideF12(Sender,Value)
	if Value==nil then Value=false end;
	if _EVENT_F12==nil or type(_EVENT_F12)~='table' then _EVENT_F12 = {} end;
	local tableID = 0;
	for k,v in ipairs(_EVENT_F12) do
		if v==Sender then tableID=k break end;
	end
	if Value==true and tableID==0 then
		table.insert(_EVENT_F12,Sender);
	elseif Value==false and tableID~=0 then
		table.remove(_EVENT_F12,tableID);
	end
end


function Turbine.UI.Control.GetHideF12(Sender)
	if type(_EVENT_F12)~='table' then return false end;
	local tableID = 0;
	for k,v in ipairs(_EVENT_F12) do
		if v==Sender then tableID=k break end;
	end
	if tableID==0 then return false else return true end;
end


function Turbine.UI.Control.SetCloseEsc(Sender,Value)
	if Value==nil then Value=false end;
	if _EVENT_ESC==nil or type(_EVENT_ESC)~='table' then _EVENT_ESC = {} end;
	local tableID = 0;
	for k,v in ipairs(_EVENT_ESC) do
		if v==Sender then tableID=k break end;
	end
	if Value==true and tableID==0 then
		table.insert(_EVENT_ESC,Sender);
	elseif Value==false and tableID~=0 then
		table.remove(_EVENT_ESC,tableID);
	end
end


function Turbine.UI.Control.GetCloseEsc(Sender)
	if type(_EVENT_ESC)~='table' then return false end;
	local tableID = 0;
	for k,v in ipairs(_EVENT_ESC) do
		if v==Sender then tableID=k break end;
	end
	if tableID==0 then return false else return true end;
end


function HandleF12Event()
	if type(_EVENT_F12)~='table' then return end;
	if _OPEN_F12==nil then _OPEN_F12 = {} end;
	if AREHIDDENF12==nil then AREHIDDENF12 = false end;
	if AREHIDDENF12==true then
		for k,v in ipairs(_OPEN_F12) do v:SetVisible(true) end;
		_OPEN_F12 = {};
	else
		for k,v in ipairs(_EVENT_F12) do
			if v:IsVisible()==true then
				table.insert(_OPEN_F12,v);
				v:Close();
			end
		end
	end
	AREHIDDENF12 = not AREHIDDENF12;
end


function HandleEscEvent()
	if type(_EVENT_ESC)~='table' then return false end;
	for k,v in pairs(_EVENT_ESC) do
		v:Close();
	end
end


function GetStatPrefix(statID)
	return "+";
end


function GetStatSuffix(statID)
	if statID==23 or statID==29 then
		return "%";
	else
		return "";
	end
end


function GetItemDatabaseName(ItemID)
	if ItemID == nil then return end;
	if _ITEMSDB[ItemID] ~= nil then
		if _ITEMSDB[ItemID][1][LANGID] ~= nil and _ITEMSDB[ItemID][1][LANGID] ~= "" then
			return _ITEMSDB[ItemID][1][LANGID];
		else
			return _ITEMSDB[ItemID][1][1];
		end
	end
end


function GetDropDownSearchID(SENDER,SEARCHTABLE)
	if SENDER == nil or SEARCHTABLE == nil or type (SEARCHTABLE) ~= 'table' then return end;
	local SearchID = 1;
	for k,v in pairs (SEARCHTABLE) do
		if v[LANGID] == SENDER:GetText() then
			SearchID = k;
			break;
		end
	end
	return SearchID;
end


function NewItemInfo(itemID)
	if itemID == nil then return end;
	local itemHex = Utils.TO_HEX(itemID);

	local cItemInspect = Turbine.UI.Lotro.Quickslot();
	cItemInspect:SetSize(1,1);
	cItemInspect:SetPosition(0,0);
	cItemInspect:SetVisible(false);

	local cItemInfo = Turbine.UI.Lotro.ItemInfoControl();
	cItemInfo:SetSize(36,36);
	cItemInfo:SetAllowDrop(false);
	cItemInfo:SetVisible(true);

	local function SetInspectIcon() 	-- PCALL THIS incase item does not exist
		cItemInspect:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item, "0x0,0x" .. itemHex));
	end

	if pcall(SetInspectIcon) then
		cItemInspect:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Item, "0x0,0x" .. itemHex));
		local itemInfo = cItemInspect:GetShortcut():GetItem():GetItemInfo();
		cItemInfo:SetItemInfo(itemInfo);
		cItemInfo:SetQuantity(1);
	end

	cItemInspect = nil;
	return cItemInfo;
end


function NewPagenateButton()
	local btn = Turbine.UI.Lotro.Button();
	btn:SetSize(22,20);
	return btn;
end


function RegisterEditEvent(control)	 -- Filters numbers only
	if control == nil then return end;

	control.TextChanged = function ()
		control:SetText(string.match(control:GetText(),'%d*%,*%d*%.*%d*')); 	-- eg 1,000 or 102.5 or 1,263.87
	end

	control.FocusGained = function()
		control:SetWantsKeyEvents(true);
	end

	control.FocusLost = function()
		control:SetWantsKeyEvents(false);
	end
end


-- This function creates the list items used in advanced search
function NewListControl(Label)

	if Label == nil then Label = "" end;

	local cItemContainer = Turbine.UI.Control();
	cItemContainer:SetHeight(20);

	local cBackLeft = Turbine.UI.Control();
	cBackLeft:SetParent(cItemContainer);
	cBackLeft:SetSize(3,20);
	cBackLeft:SetPosition(0,0);
	cBackLeft:SetBackground(_IMAGES.LISTITEMS.LEFT);
	cBackLeft:SetBlendMode(4);
	cBackLeft:SetMouseVisible(false);

	local cBackMiddle = Turbine.UI.Control();
	cBackMiddle:SetParent(cItemContainer);
	cBackMiddle:SetSize(5,20);
	cBackMiddle:SetPosition(3,0);
	cBackMiddle:SetBackground(_IMAGES.LISTITEMS.MIDDLE);
	cBackMiddle:SetBlendMode(4);
	cBackMiddle:SetMouseVisible(false);

	local cBackRight = Turbine.UI.Control();
	cBackRight:SetParent(cItemContainer);
	cBackRight:SetSize(3,20);
	cBackRight:SetPosition(8,0);
	cBackRight:SetBackground(_IMAGES.LISTITEMS.RIGHT);
	cBackRight:SetBlendMode(4);
	cBackRight:SetMouseVisible(false);

	local lblSearchItem = Turbine.UI.TextBox();
	lblSearchItem:SetParent(cItemContainer);
	lblSearchItem:SetHeight(cItemContainer:GetHeight()-2);
	lblSearchItem:SetPosition(5,2);
	lblSearchItem:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblSearchItem:SetOutlineColor(Turbine.UI.Color.Black);
	lblSearchItem:SetFont(_FONTS[2]);
	lblSearchItem:SetMultiline(false);
	lblSearchItem:SetSelectable(false);
	lblSearchItem:SetMouseVisible(false);
	lblSearchItem:SetText(Label);
	Utils.AutoWidth(lblSearchItem);

	cItemContainer:SetWidth(lblSearchItem:GetWidth()+10);
	cBackRight:SetLeft(cItemContainer:GetWidth()-3);
	cBackMiddle:SetWidth(cItemContainer:GetWidth()-6);

	return cItemContainer,lblSearchItem;
end


function NewItemContainer(width,height)
	if width == nil then width = 100 end;
	if height == nil then height = 12 end;
	local newContainer = Turbine.UI.Control();
	newContainer:SetSize(width,height);
	return newContainer;
end


function NewItemInfoLabel(width,height)
	if width == nil then width = 100 end;
	if height == nil then height = 12 end;
	local lblItemInfo = Turbine.UI.Label();
	lblItemInfo:SetSize(width,height);
	lblItemInfo:SetForeColor(_COLORS[3]);
	lblItemInfo:SetFont(_FONTS[4]);
	lblItemInfo:SetOutlineColor(Turbine.UI.Color(0,0,0));
	lblItemInfo:SetFontStyle(Turbine.UI.FontStyle.Outline);
	lblItemInfo:SetMultiline(false);
	lblItemInfo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	return lblItemInfo;
end


function NewWindowLabel(parent,width,height,left,top,text)
	label = Turbine.UI.Label();
	if width == nil then width = 150 end;
	if height == nil then height = 18 end;
	if left == nil then left = 0 end;
	if top == nil then top = 0 end;
	if text == nil then text = "" end;
	if parent ~= nil then label:SetParent(parent) end;
	label:SetSize(width,height);
	label:SetPosition(left,top);
	label:SetFont(_FONTS[1]);
	label:SetForeColor(_COLORS[4]);
	label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	label:SetText(text);
	return label;
end


function NewBuildStatLabel(parent,left,top)
	label = Turbine.UI.Label();
	if left == nil then left = 0 end;
	if top == nil then top = 0 end;
	if parent ~= nil then label:SetParent(parent) end;
	label:SetSize(50,18);
	label:SetPosition(left,top);
	label:SetFont(_FONTS[4]);
	label:SetForeColor(Turbine.UI.Color.LightGray);
	label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	label:SetText("0");
	return label;
end


function NewScrollBar(control,orientation,parent)
	if control == nil then return end;
	if orientation == nil then orientation = "vertical" end;
	scrollBar = Turbine.UI.Lotro.ScrollBar();
	if parent ~= nil then scrollBar:SetParent(parent) end;
	if orientation == "horizontal" then
		scrollBar:SetSize(control:GetWidth(),11);
		scrollBar:SetPosition(control:GetLeft(),control:GetTop()+control:GetHeight()+1);
		scrollBar:SetOrientation(Turbine.UI.Orientation.Horizontal);
		control:SetHorizontalScrollBar(scrollBar);
	else	-- vertical
		scrollBar:SetSize(11,control:GetHeight());
		scrollBar:SetPosition(control:GetLeft()+control:GetWidth()+1,control:GetTop());
		scrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);
		control:SetVerticalScrollBar(scrollBar);
	end
	scrollBar:SetVisible(false);
	return scrollBar;
end


function NewWindowTextBox(parent,width,height,left,top,text)
	textbox = Turbine.UI.Lotro.TextBox();
	if width == nil then width = 120 end;
	if height == nil then height = 22 end;
	if left == nil then left = 0 end;
	if top == nil then top = 0 end;
	if text == nil then text = "" end;
	if parent ~= nil then textbox:SetParent(parent) end;
	textbox:SetPosition(left,top);
	textbox:SetSize(width,height);
	textbox:SetSelectable(true);
	textbox:SetMultiline(false);
	textbox:SetForeColor(_COLORS[3]);
	textbox:SetFont(_FONTS[1]);
	textbox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	textbox:SetText(text);
	return textbox;
end

