
SETTINGS = {}; -- Table used when loading settings.
_TABLES = {};
_GAMEVALUES = {};
_SEARCHHISTORY = {};	-- Table used for saving/loading search history
_SEARCHRESULTS = {};	-- Table used for storing IDs of matching results
_SCANINFO = {};			-- Table used for storing scan search info
_SELECTEDSCANS = {};	-- Table used for storing selected scans to add
_BOOKMARKS = {};		-- Table used for storing bookmarked items
_COMPARE = {};			-- Table used for holding items to be compared
_BUILDS = {};			-- Table used for holding player builds
_ITEMS = {};			-- Table used for holding player items
_PLAYERSTATS = {};		-- Table used for holding player stat info

V_SETTINGS = 1;			-- Table version number, used when saving/loading each table to check against updates.
V_SEARCHHISTORY = 1;
V_BOOKMARKS = 1;
V_BUILDS = 1;
V_ITEMS = 1;

SCREENWIDTH = Turbine.UI.Display.GetWidth();
SCREENHEIGHT = Turbine.UI.Display.GetHeight();
MINWIDTH = 1000;
MINHEIGHT = 655;
ITEMINFOWIDTH = 220; -- Width used for search results item info display
LANGID = 1;
PLAYERCHAR = Turbine.Gameplay.LocalPlayer.GetInstance();
PLAYERLEVEL = PLAYERCHAR:GetLevel();
PLAYERCLASS = PLAYERCHAR:GetClass();
LEVELCAP = 95;
SEARCH_PAGE = 1;
SCAN_PAGE = 1;

PLAYERCHAR.LevelChanged = function()
	PLAYERLEVEL = PLAYERCHAR:GetLevel();
end

_COLORS =
{
	[1] = Turbine.UI.Color(0.05,0.05,0.1);	-- Edit boxes forecolor
	[2] = Turbine.UI.Color.SlateGray; 		-- Edit boxes forecolor (greyed out)
	[3] = Turbine.UI.Color.Ivory;	 		-- Edit boxes backcolor
	[4] = Turbine.UI.Color.Khaki;			-- Labels
	[5] = Turbine.UI.Color.Black;			-- Deselected search items (listboxes)
	[6] = Turbine.UI.Color(0.85,0.65,0);	-- Highlight outline colour - menu items
	[7] = Turbine.UI.Color.DodgerBlue;		-- History Colour
	[8] = Turbine.UI.Color(0.1,0.1,0.1);	-- Alt line in compare grid
	[9] = Turbine.UI.Color(0.7,0.7,0.8);	-- Vertical line in compare grid
	[10] = Turbine.UI.Color.Red;			-- Negative var in compare grid
	[11] = Turbine.UI.Color.Lime;			-- Positive var in compare grid
	[12] = Turbine.UI.Color((0/255),(39/255),(72/255));		-- Selected item in channel scan list
	[13] = Turbine.UI.Color.Yellow;			-- Item list labels in advanced search
	[14] = Turbine.UI.Color((0/255),(17/255),(45/255)); -- Scan items selected colour
};

_FONTS =
{
	[1] = Turbine.UI.Lotro.Font.Verdana14;	-- Edit boxes
	[2] = Turbine.UI.Lotro.Font.Verdana14;	-- Search Controls - TilingBoxes
	[3] = Turbine.UI.Lotro.Font.TrajanPro14; -- Item name in search results iteminfo
	[4] = Turbine.UI.Lotro.Font.Verdana12;	-- Search results item info
	[5] = Turbine.UI.Lotro.Font.Verdana14;	-- Chat channels in popup
	[6] = Turbine.UI.Lotro.Font.TrajanPro18;	-- search window welcome message
	[7] = Turbine.UI.Lotro.Font.Verdana10;	-- Chat channels in popup
};

_QUALITYCOLORS =
{
	[1] = Turbine.UI.Color.White;			-- Common
	[2] = Turbine.UI.Color.Yellow;			-- Uncommon -- done
	[3] = Turbine.UI.Color.Magenta;			-- Rare -- done
	[4] = Turbine.UI.Color.Aqua;			-- Incomparable -- done
	[5] = Turbine.UI.Color.Orange;			-- Legendary -- done
};

-- Default Settings
DEFAULT_SETTINGS =
	{
	["COMPAREMAX"] = 6;
	["ALLOWSCANS"] = true;
	["AUTOREMOVESCANS"] = true;
	["SCANMAX"] = 250;

	["MAINWIN"] =
		{
		["X"] = 60;
		["Y"] = 60;
		};
	["SEARCHWIN"] =
		{
		["X"] = SCREENWIDTH*0.1;
		["Y"] = SCREENHEIGHT*0.1;
		};
	["BUILDWIN"] =
		{
		["X"] = (SCREENWIDTH/2)-350;
		["Y"] = SCREENHEIGHT/4;
		};
	["ICON"] =
		{
		["X"] = 10;
		["Y"] = 10;
		};
	["SCAN"] =
		{
		["PREVID"] = 1879049230;
		["MAX"] = 10000;
		};

	};

