
function DrawBuildWin()

	wBuildWin = Turbine.UI.Lotro.Window();
	wBuildWin:SetSize(700,570);
	wBuildWin:SetPosition(SETTINGS.BUILDWIN.X,SETTINGS.BUILDWIN.Y);
	wBuildWin:SetText(_LABELS[83][LANGID]);
	wBuildWin:SetHideF12(true);
	wBuildWin:SetCloseEsc(false);
	wBuildWin["BuildID"] = 0;

	Utils.Onscreen(wBuildWin);

	-- SLOTS CONTAINTER --------------------------------------------------------------------------------------
	builds_SlotContainer = Turbine.UI.Control();
	builds_SlotContainer:SetParent(wBuildWin);
	builds_SlotContainer:SetSize(415,474);
	builds_SlotContainer:SetPosition(20,40);
	builds_SlotContainer:SetBackground(_IMAGES.BACKGROUNDS.BUILDS_SLOTS);
	builds_SlotContainer:SetBlendMode(4);

	builds_cSlots = {};
	builds_cSlotBack = {};

	for i=1, 18 do
		builds_cSlotBack[i] = Turbine.UI.Control();
		builds_cSlotBack[i]:SetParent(builds_SlotContainer);
		builds_cSlotBack[i]:SetSize(44,44);
		builds_cSlotBack[i]:SetVisible(true);
		builds_cSlotBack[i]:SetBlendMode(4);
		builds_cSlotBack[i]:SetToolTip(_TABLES.BUILDSLOTS[i][LANGID]);
		builds_cSlotBack[i]:SetBackground(_IMAGES.SLOTS[i]);

		builds_cSlots[i] = Turbine.UI.Lotro.ItemInfoControl();
		builds_cSlots[i]:SetParent(builds_cSlotBack[i]);
		builds_cSlots[i]:SetSize(36,36);
		builds_cSlots[i]:SetPosition(3,3);
		builds_cSlots[i]:SetVisible(false);
		builds_cSlots[i]:SetQuantity(1);
		builds_cSlots[i]["ItemID"] = 0;

		builds_cSlots[i].MouseClick = function (Sender,Args)
			if Args.Button == Turbine.UI.MouseButton.Right then
				local contextMenu = Turbine.UI.ContextMenu();
				local menuItems = contextMenu:GetItems();
				local cRemove = Turbine.UI.MenuItem(_LABELS[19][LANGID]);
				cRemove.Click = function()
					_BUILDS[wBuildWin.BuildID][i] = nil;
					ClearSlotItems(i);
					SwitchBuilds(wBuildWin.BuildID);
				end
				menuItems:Add(cRemove);
				local cSearch = Turbine.UI.MenuItem(_LABELS[2][LANGID]);
				cSearch.Click = function()
					PrepareResults({builds_cSlots[i].ItemID});
				end
				menuItems:Add(cSearch);
				contextMenu:ShowMenu();
			end
		end

	end

	-- Left side
	builds_cSlotBack[13]:SetPosition(10,10);	-- Left Ear
	builds_cSlotBack[14]:SetPosition(10,builds_cSlotBack[13]:GetTop()+49);	-- Right Ear
	builds_cSlotBack[10]:SetPosition(10,builds_cSlotBack[14]:GetTop()+49);	-- Neck
	builds_cSlotBack[8]:SetPosition(10,builds_cSlotBack[10]:GetTop()+49);		-- Left Brac
	builds_cSlotBack[9]:SetPosition(10,builds_cSlotBack[8]:GetTop()+49);		-- Right Brac
	builds_cSlotBack[11]:SetPosition(10,builds_cSlotBack[9]:GetTop()+49);	-- Left Ring
	builds_cSlotBack[12]:SetPosition(10,builds_cSlotBack[11]:GetTop()+49);	-- Right Ring
	builds_cSlotBack[15]:SetPosition(10,builds_cSlotBack[12]:GetTop()+49);	-- Pocket
	-- Right side
	builds_cSlotBack[1]:SetPosition(builds_SlotContainer:GetWidth()-53,10);		-- Head
	builds_cSlotBack[6]:SetPosition(builds_SlotContainer:GetWidth()-53,builds_cSlotBack[1]:GetTop()+49);		-- Shoulders
	builds_cSlotBack[7]:SetPosition(builds_SlotContainer:GetWidth()-53,builds_cSlotBack[6]:GetTop()+49);		-- Back
	builds_cSlotBack[2]:SetPosition(builds_SlotContainer:GetWidth()-53,builds_cSlotBack[7]:GetTop()+49);		-- Chest
	builds_cSlotBack[4]:SetPosition(builds_SlotContainer:GetWidth()-53,builds_cSlotBack[2]:GetTop()+49);		-- Hand
	builds_cSlotBack[3]:SetPosition(builds_SlotContainer:GetWidth()-53,builds_cSlotBack[4]:GetTop()+49);		-- Legs
	builds_cSlotBack[5]:SetPosition(builds_SlotContainer:GetWidth()-53,builds_cSlotBack[3]:GetTop()+49);		-- Feet
	-- Bottom
	builds_cSlotBack[16]:SetPosition((builds_SlotContainer:GetWidth()/2)-74,builds_SlotContainer:GetHeight()-53);	-- Primary Weapon
	builds_cSlotBack[17]:SetPosition(builds_cSlotBack[16]:GetLeft()+builds_cSlotBack[16]:GetWidth()+10,builds_cSlotBack[16]:GetTop());	-- Secondary Weapon/Shield
	builds_cSlotBack[18]:SetPosition(builds_cSlotBack[17]:GetLeft()+builds_cSlotBack[17]:GetWidth()+10,builds_cSlotBack[16]:GetTop());	-- Ranged Weapon

	builds_txtName = NewWindowTextBox(builds_SlotContainer,240,36,66,13);
	builds_txtName:SetLeft((builds_SlotContainer:GetWidth()/2)-(builds_txtName:GetWidth()/2));
	builds_txtName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	builds_txtName:SetMultiline(true);

	builds_txtName.TextChanged = function ()
		local charLimit = 50;
		if string.len(builds_txtName:GetText())>charLimit then builds_txtName:SetText(string.sub(builds_txtName:GetText(),1,charLimit)) end;
		if wBuildWin.BuildID ~= nil and wBuildWin.BuildID ~= 0 then
			_BUILDS[wBuildWin.BuildID][19] = builds_txtName:GetText();
			builds_lstTabs:GetItem(wBuildWin.BuildID):SetText(builds_txtName:GetText());
		end
	end

	builds_btnEquipment = Turbine.UI.Lotro.Button();
	builds_btnEquipment:SetParent(builds_SlotContainer);
	builds_btnEquipment:SetWidth(140);
	builds_btnEquipment:SetPosition((builds_SlotContainer:GetWidth()/2)-(builds_btnEquipment:GetWidth()/2),builds_txtName:GetTop()+builds_txtName:GetHeight()+10);
	builds_btnEquipment:SetText(_LABELS[97][LANGID]);

	builds_btnEquipment.Click = function ()
		Includes.ShowEquipmentWin();
	end

	builds_btnCompare = Turbine.UI.Lotro.Button();
	builds_btnCompare:SetParent(builds_SlotContainer);
	builds_btnCompare:SetWidth(105);
	builds_btnCompare:SetPosition((builds_SlotContainer:GetWidth()/2)-(builds_btnCompare:GetWidth()/2),builds_btnEquipment:GetTop());
	builds_btnCompare:SetText(_LABELS[22][LANGID]);
	builds_btnCompare:SetToolTip(_TOOLTIPS[23][LANGID]);

	builds_btnCompare.Click = function ()
		AddToCompare(wBuildWin.BuildID,2);
	end

	builds_lblBonus = NewWindowLabel(builds_SlotContainer,120,18,builds_txtName:GetLeft(),102,_TABLES.SETINFO[3][LANGID]..":");
	builds_lblBonus:SetForeColor(Turbine.UI.Color.Yellow);
	builds_lblBonus:SetOutlineColor(Turbine.UI.Color.Black);
	builds_lblBonus:SetFontStyle(Turbine.UI.FontStyle.Outline);

	builds_lstBonus = Turbine.UI.ListBox();
	builds_lstBonus:SetParent(builds_SlotContainer);
	builds_lstBonus:SetSize(builds_txtName:GetWidth(),285);
	builds_lstBonus:SetPosition(builds_txtName:GetLeft(),builds_lblBonus:GetTop()+22);

	builds_sbBonus = NewScrollBar(builds_lstBonus,"vertical",builds_SlotContainer);


	-- TABS CONTAINTER --------------------------------------------------------------------------------------
	builds_TabsContainer = Turbine.UI.Control();
	builds_TabsContainer:SetParent(wBuildWin);
	builds_TabsContainer:SetSize(wBuildWin:GetWidth()-40,25);
	builds_TabsContainer:SetPosition(20,wBuildWin:GetHeight()-50);
	builds_TabsContainer:SetBackground(_IMAGES.BACKGROUNDS.BUILDS_TABSBAR);

	builds_tabsLeft = Utils.Button();
	builds_tabsLeft:SetPosition(0,0);
	builds_tabsLeft:SetSize(25,25);
	builds_tabsLeft:SetImageNormal(_IMAGES.LEFTARROW[1]);
	builds_tabsLeft:SetImageOver(_IMAGES.LEFTARROW[2]);
	builds_tabsLeft:SetImageDown(_IMAGES.LEFTARROW[3]);
	builds_tabsLeft:SetImageDisabled(_IMAGES.LEFTARROW[4]);

	builds_tabsRight = Utils.Button();
	builds_tabsRight:SetPosition(builds_TabsContainer:GetWidth()-25,0);
	builds_tabsRight:SetSize(25,25);
	builds_tabsRight:SetImageNormal(_IMAGES.RIGHTARROW[1]);
	builds_tabsRight:SetImageOver(_IMAGES.RIGHTARROW[2]);
	builds_tabsRight:SetImageDown(_IMAGES.RIGHTARROW[3]);
	builds_tabsRight:SetImageDisabled(_IMAGES.RIGHTARROW[4]);

	builds_tabsThumb = Turbine.UI.Control();
	builds_tabsThumb:SetSize(1,1);

	builds_sbTab = Turbine.UI.ScrollBar();
	builds_sbTab:SetParent(builds_TabsContainer);
	builds_sbTab:SetSize(builds_TabsContainer:GetSize());
	builds_sbTab:SetVisible(false);
	builds_sbTab:SetOrientation(Turbine.UI.Orientation.Horizontal);
	builds_sbTab:SetDecrementButton(builds_tabsLeft);
	builds_sbTab:SetIncrementButton(builds_tabsRight);
	builds_sbTab:SetThumbButton(builds_tabsThumb);

	builds_lstTabs = Turbine.UI.ListBox();
	builds_lstTabs:SetParent(builds_TabsContainer);
	builds_lstTabs:SetSize(builds_TabsContainer:GetWidth()-50,25);
	builds_lstTabs:SetPosition(25,0);
	builds_lstTabs:SetOrientation(Turbine.UI.Orientation.Horizontal);
	builds_lstTabs:SetZOrder(10000);
	builds_lstTabs:SetHorizontalScrollBar(builds_sbTab);

	-- StATS CONTAINTER --------------------------------------------------------------------------------------
	builds_StatsContainer = Turbine.UI.Control();
	builds_StatsContainer:SetParent(wBuildWin);
	builds_StatsContainer:SetPosition(builds_SlotContainer:GetLeft()+builds_SlotContainer:GetWidth()+20,builds_SlotContainer:GetTop());
	builds_StatsContainer:SetSize(225,394);
	builds_StatsContainer:SetBackground(_IMAGES.BACKGROUNDS.BUILDS_STATS);

	builds_lblBasicStats = NewWindowLabel(builds_StatsContainer,200,18,10,5,_LABELS[85][LANGID]..":");

	builds_lblMorale = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblBasicStats:GetTop()+20,_LABELS[87][LANGID]);
	builds_lblMorale:SetForeColor(Turbine.UI.Color.LimeGreen);
	builds_MoraleVal = NewBuildStatLabel(builds_StatsContainer,builds_lblMorale:GetLeft()+builds_lblMorale:GetWidth()+3,builds_lblMorale:GetTop());

	builds_lblPower = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblMorale:GetTop()+20,_LABELS[88][LANGID]);
	builds_lblPower:SetForeColor(Turbine.UI.Color.DeepSkyBlue);
	builds_PowerVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblPower:GetTop());

	builds_lblArmour = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblPower:GetTop()+20,_LABELS[12][LANGID]);
	builds_lblArmour:SetForeColor(Turbine.UI.Color.Tan);
	builds_ArmourVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblArmour:GetTop());

	builds_lblMight = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblArmour:GetTop()+20,_TABLES.STATS[7][LANGID]);
	builds_lblMight:SetForeColor(Turbine.UI.Color.Ivory);
	builds_MightVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblMight:GetTop());

	builds_lblAgility = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblMight:GetTop()+20,_TABLES.STATS[8][LANGID]);
	builds_lblAgility:SetForeColor(Turbine.UI.Color.Ivory);
	builds_AgilityVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblAgility:GetTop());

	builds_lblVitality = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblAgility:GetTop()+20,_TABLES.STATS[9][LANGID]);
	builds_lblVitality:SetForeColor(Turbine.UI.Color.Ivory);
	builds_VitalityVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblVitality:GetTop());

	builds_lblWill = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblVitality:GetTop()+20,_TABLES.STATS[10][LANGID]);
	builds_lblWill:SetForeColor(Turbine.UI.Color.Ivory);
	builds_WillVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblWill:GetTop());

	builds_lblFate = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblWill:GetTop()+20,_TABLES.STATS[11][LANGID]);
	builds_lblFate:SetForeColor(Turbine.UI.Color.Ivory);
	builds_FateVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblFate:GetTop());

	builds_lblOffence = NewWindowLabel(builds_StatsContainer,200,18,10,builds_lblFate:GetTop()+20,_LABELS[86][LANGID]..":");

	builds_lblCrit = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblOffence:GetTop()+20,_TABLES.STATS[12][LANGID]);
	builds_lblCrit:SetForeColor(Turbine.UI.Color.Ivory);
	builds_CritVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblCrit:GetTop());

	builds_lblPMast = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblCrit:GetTop()+20,_LABELS[89][LANGID]);
	builds_lblPMast:SetForeColor(Turbine.UI.Color.Ivory);
	builds_PMastVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblPMast:GetTop());

	builds_lblTMast = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblPMast:GetTop()+20,_LABELS[90][LANGID]);
	builds_lblTMast:SetForeColor(Turbine.UI.Color.Ivory);
	builds_TMastVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblTMast:GetTop());

	builds_lblDefence = NewWindowLabel(builds_StatsContainer,200,18,10,builds_lblTMast:GetTop()+20,_LABELS[91][LANGID]..":");

	builds_lblBlock = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblDefence:GetTop()+20,_LABELS[92][LANGID]);
	builds_lblBlock:SetForeColor(Turbine.UI.Color.Ivory);
	builds_BlockVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblBlock:GetTop());

	builds_lblParry = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblBlock:GetTop()+20,_LABELS[93][LANGID]);
	builds_lblParry:SetForeColor(Turbine.UI.Color.Ivory);
	builds_ParryVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblParry:GetTop());

	builds_lblEvade = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblParry:GetTop()+20,_LABELS[94][LANGID]);
	builds_lblEvade:SetForeColor(Turbine.UI.Color.Ivory);
	builds_EvadeVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblEvade:GetTop());

	builds_lblPMit = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblEvade:GetTop()+20,_TABLES.STATS[25][LANGID]);
	builds_lblPMit:SetForeColor(Turbine.UI.Color.Ivory);
	builds_PMitVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblPMit:GetTop());

	builds_lblTMit = NewWindowLabel(builds_StatsContainer,150,18,10,builds_lblPMit:GetTop()+20,_TABLES.STATS[26][LANGID]);
	builds_lblTMit:SetForeColor(Turbine.UI.Color.Ivory);
	builds_TMitVal = NewBuildStatLabel(builds_StatsContainer,builds_MoraleVal:GetLeft(),builds_lblTMit:GetTop());


	-- BUTTON CONTAINTER ----------------------------------------------------------------------------------------------------
	builds_ButtonContainer = Turbine.UI.Control();
	builds_ButtonContainer:SetParent(wBuildWin);
	builds_ButtonContainer:SetPosition(builds_StatsContainer:GetLeft(),builds_StatsContainer:GetTop()+builds_StatsContainer:GetHeight()+13);
	builds_ButtonContainer:SetSize(builds_StatsContainer:GetWidth(),builds_SlotContainer:GetTop()+builds_SlotContainer:GetHeight()-builds_ButtonContainer:GetTop());


	builds_btnClear = Turbine.UI.Lotro.Button();
	builds_btnClear:SetParent(builds_ButtonContainer);
	builds_btnClear:SetWidth(100);
	builds_btnClear:SetPosition(10,5);
	builds_btnClear:SetText(_LABELS[4][LANGID]);
	builds_btnClear:SetToolTip(_TOOLTIPS[19][LANGID]);

	builds_btnClear.Click = function ()
		local msg = Utils.MessageBox(_LABELS[99][LANGID],"MBYESNO")
		msg.ButtonClick = function (sender,args) -- Event executed when a button is pressed.. args returns a table with the value of the button pressed
			if args.Button == "MBYES" then
				ClearSlotItems();
				for i=1,18 do
					if _BUILDS[wBuildWin.BuildID][i] ~= nil then _BUILDS[wBuildWin.BuildID][i] = nil end;
				end
				UpdateBuildBonuses(_BUILDS[wBuildWin.BuildID]);
				UpdateBuildStats(wBuildWin.BuildID);
			end
		end
	end

	builds_btnCopy = Turbine.UI.Lotro.Button();
	builds_btnCopy:SetParent(builds_ButtonContainer);
	builds_btnCopy:SetWidth(100);
	builds_btnCopy:SetPosition(builds_ButtonContainer:GetWidth()-110,5);
	builds_btnCopy:SetText(_LABELS[95][LANGID]);
	builds_btnCopy:SetToolTip(_TOOLTIPS[20][LANGID]);

	builds_btnCopy.Click = function ()
		Includes.DisplayBuildCopyPopup(wBuildWin.BuildID);
	end

	builds_btnList = Turbine.UI.Lotro.Button();
	builds_btnList:SetParent(builds_ButtonContainer);
	builds_btnList:SetWidth(100);
	builds_btnList:SetPosition(10,32);
	builds_btnList:SetText(_LABELS[96][LANGID]);
	builds_btnList:SetToolTip(_TOOLTIPS[21][LANGID]);

	builds_btnList.Click = function ()
		ListBuild();
	end

	builds_btnDelete = Turbine.UI.Lotro.Button();
	builds_btnDelete:SetParent(builds_ButtonContainer);
	builds_btnDelete:SetWidth(100);
	builds_btnDelete:SetPosition(builds_btnCopy:GetLeft(),builds_btnList:GetTop());
	builds_btnDelete:SetText(_LABELS[38][LANGID]);
	builds_btnDelete:SetToolTip(_TOOLTIPS[22][LANGID]);

	builds_btnDelete.Click = function ()
		DeleteBuild(wBuildWin.BuildID)
	end


	if _BUILDS[1] == nil then _BUILDS[1]={[19]=_LABELS[13][LANGID];} end; -- Check for equipped slot

	for i=1, #_BUILDS do
		AddBuildTab(i);
	end

	SwitchBuilds(1);

	-- Window Events --
	wBuildWin.PositionChanged = function()
		SETTINGS.BUILDWIN.X = wBuildWin:GetLeft();
		SETTINGS.BUILDWIN.Y = wBuildWin:GetTop();
	end

end


function HandleCopyRequest(originBuild,destinationBuild)
	if originBuild==nil or destinationBuild==nil then return end;
	if _BUILDS[originBuild]==nil then return end;
	if _BUILDS[destinationBuild]==nil then
		_BUILDS[destinationBuild] = {};
		_BUILDS[destinationBuild][19] = _LABELS[84][LANGID];
		AddBuildTab(destinationBuild);
	end
	for i=1,18 do
		_BUILDS[destinationBuild][i] = nil;
		if _BUILDS[originBuild][i] ~= nil then _BUILDS[destinationBuild][i] = _BUILDS[originBuild][i] end;
	end
	SwitchBuilds(destinationBuild);
end


function ListBuild(buildID)
	if buildID == nil then buildID = wBuildWin.BuildID end;
	if _BUILDS[buildID] == nil or _BUILDS[buildID][19] == nil then return end;
	local output = "<rgb=#00BFFF>".._BUILDS[buildID][19]..": </rgb>";
	for i=1, 18 do
		if _BUILDS[buildID][i] ~= nil and _ITEMSDB[_BUILDS[buildID][i]] ~= nil then
			local itemName = "";
			if _ITEMSDB[_BUILDS[buildID][i]][1][LANGID] ~= "" then
				itemName = _ITEMSDB[_BUILDS[buildID][i]][1][LANGID];
			else
				itemName = _ITEMSDB[_BUILDS[buildID][i]][1][1];
			end
			local slot = _TABLES.SLOT[_ITEMSDB[_BUILDS[buildID][i]][5]][LANGID];
			output = output .. "\n" .. itemName .. " (" .. slot .. ") ";
		end
	end
	print(output);
end


function AddBuildTab(buildID)
	if buildID == nil then return end;

	local buildName = _BUILDS[buildID][19];

	local cItemContainer = Turbine.UI.Control();
	cItemContainer:SetSize(80,25);
	cItemContainer["BuildID"] = buildID;

	local imgTabLeft = Turbine.UI.Control();
	imgTabLeft:SetParent(cItemContainer);
	imgTabLeft:SetSize(5,24);
	imgTabLeft:SetPosition(0,1);
	imgTabLeft:SetBackground(_IMAGES.TABS.LEFT);
	imgTabLeft:SetMouseVisible(false);

	local imgTabMiddle = Turbine.UI.Control();
	imgTabMiddle:SetParent(cItemContainer);
	imgTabMiddle:SetSize(11,24);
	imgTabMiddle:SetPosition(5,1);
	imgTabMiddle:SetBackground(_IMAGES.TABS.MIDDLE);
	imgTabMiddle:SetMouseVisible(false);

	local imgTabRight = Turbine.UI.Control();
	imgTabRight:SetParent(cItemContainer);
	imgTabRight:SetSize(5,24);
	imgTabRight:SetPosition(17,1);
	imgTabRight:SetBackground(_IMAGES.TABS.RIGHT);
	imgTabRight:SetMouseVisible(false);

	local lblBuild = Turbine.UI.TextBox();
	lblBuild:SetParent(cItemContainer);
	lblBuild:SetSize(1,25);
	lblBuild:SetPosition(8,0);
	lblBuild:SetFont(_FONTS[3]);
	lblBuild:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	lblBuild:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblBuild:SetMultiline(false);
	lblBuild:SetMouseVisible(false);

	local itemClick = function ()
		SwitchBuilds(cItemContainer.BuildID);
	end
	AddCallback(cItemContainer, "MouseClick", itemClick);

	local itemEnter = function ()
		lblBuild:SetOutlineColor(Turbine.UI.Color(0.85,0.65,0));
		lblBuild:SetForeColor(Turbine.UI.Color(1,1,1));
		lblBuild:SetFontStyle(8);
	end
	AddCallback(cItemContainer, "MouseEnter", itemEnter);

	local itemLeave = function ()
		lblBuild:SetOutlineColor(Turbine.UI.Color(0,0,0));
		lblBuild:SetFontStyle(0);
		lblBuild:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	end
	AddCallback(cItemContainer, "MouseLeave", itemLeave);

	cItemContainer.SetText = function (Sender,Text)
		if string.len(Text)>15 then
			cItemContainer:SetToolTip(Text);
			Text = string.sub(Text,1,13).."..";
		else
			cItemContainer:SetToolTip();
		end
		lblBuild:SetText(Text);
		Utils.AutoWidth(lblBuild);
		cItemContainer:SetWidth(lblBuild:GetWidth()+16);
		imgTabRight:SetLeft(cItemContainer:GetWidth()-5);
		imgTabMiddle:SetWidth(cItemContainer:GetWidth()-10);
	end

	cItemContainer:SetText(buildName);
	builds_lstTabs:AddItem(cItemContainer);

end


function ShowBuildWin()
	if wBuildWin == nil then DrawBuildWin() end;

	if wBuildWin:IsVisible() == false then wBuildWin:SetVisible(true) end;
	wBuildWin:Activate();
end


function DeleteBuild(buildID)
	if buildID == nil or _BUILDS[buildID] == nil or buildID == 1 then return end;
	local msg = Utils.MessageBox(_LABELS[98][LANGID],"MBYESNO");
	msg.ButtonClick = function (sender,args) -- Event executed when a button is pressed.. args returns a table with the value of the button pressed
		if args.Button == "MBYES" then
			table.remove(_BUILDS,buildID);
			for i=buildID, builds_lstTabs:GetItemCount() do
				builds_lstTabs:GetItem(i).BuildID = builds_lstTabs:GetItem(i).BuildID - 1;
			end
			builds_lstTabs:RemoveItemAt(buildID);
			SwitchBuilds(buildID-1);
		end
	end
end


function AddToBuild(buildID,itemID,itemSlot)	-- buildID -1 = new build
	if wBuildWin == nil then DrawBuildWin() end;
	if _BUILDS[buildID] == nil then
		_BUILDS[buildID] = {};
		_BUILDS[buildID][19] = _LABELS[84][LANGID];
		AddBuildTab(buildID);
	end
	_BUILDS[buildID][itemSlot] = itemID;
	SwitchBuilds(buildID);
	ShowBuildWin();
end


function SwitchBuilds(buildID)
	if buildID==nil or _BUILDS[buildID]==nil then return end;
	wBuildWin.BuildID = buildID;
	ClearSlotItems();
	for i=1,18 do
		if _BUILDS[buildID][i] ~= nil then
			local itemID = _BUILDS[buildID][i];
			builds_cSlots[i]:SetItemInfo(Utils.GetItemFromID(itemID):GetItemInfo());
			builds_cSlots[i]:SetVisible(true);
			builds_cSlots[i].ItemID = itemID;
		end
	end
	if _BUILDS[buildID][19] == nil then _BUILDS[buildID][19] = _LABELS[84][LANGID] end;
	builds_txtName:SetText(_BUILDS[buildID][19]);
	if buildID == 1 then
		builds_txtName:SetEnabled(false);
		builds_btnEquipment:SetVisible(true);
		builds_btnCompare:SetVisible(false);
		builds_btnDelete:SetVisible(false);
	else
		builds_txtName:SetEnabled(true);
		builds_btnEquipment:SetVisible(false);
		builds_btnCompare:SetVisible(true);
		builds_btnDelete:SetVisible(true);
	end
	UpdateBuildBonuses(_BUILDS[buildID]);
	UpdateBuildStats(buildID);
	builds_lstTabs:EnsureVisible(buildID);
	wBuildWin:Focus();
end


function GetSetTables(buildList)
	if buildList == nil then return end;

	local _buildSets = {};
	local _setIDs = {};
	local _items = {};

	for i=1,18 do
		if buildList[i] ~= nil then table.insert(_items,buildList[i]) end;
	end

	for k,v in ipairs (_items) do
		if _setIDs[v] == nil then
			local _set = GetItemSet(v);
			if _set ~= nil and type(_set.Pieces) == 'table' then
				for pieceKey,pieceID in pairs (_set.Pieces) do
					if IsPartOfBuild(pieceID,_items) then _setIDs[pieceID] = #_buildSets+1 end;
				end
				table.insert(_buildSets,_set);
			end
		end
	end

	return _setIDs,_buildSets;
end


function UpdateBuildBonuses(buildList)
	builds_lstBonus:ClearItems();
	if buildList == nil then return end;

	local _setIDs,_buildSets = GetSetTables(buildList);

	for k,v in ipairs (_buildSets) do
		local setCount = GetSetCount(_setIDs,k);
		local lblSetName = NewWindowLabel(nil,builds_lstBonus:GetWidth(),18,0,0);
		lblSetName:SetMultiline(false);
		lblSetName:SetForeColor(_QUALITYCOLORS[5]);

		if string.len(v.Name) > 35 then
			lblSetName:SetText(string.sub(v.Name,1,34).."..");
			lblSetName:SetToolTip(v.Name);
		else
			lblSetName:SetText(v.Name);
		end

		lblSetName.MouseClick = function ()
			PrepareResults(v.Pieces);
		end
		builds_lstBonus:AddItem(lblSetName);
		if type(v.Bonus) == 'table' then
			for i=1, 7 do
				if v.Bonus[i] ~= nil and type(v.Bonus[i]) == 'table' then
					local lblEquipped = NewWindowLabel(nil,builds_lstBonus:GetWidth(),18,0,0,i.." ".._LABELS[13][LANGID]..":");
					lblEquipped:SetForeColor(_COLORS[2]);
					if i<=setCount then lblEquipped:SetForeColor(_COLORS[11]) end;
					builds_lstBonus:AddItem(lblEquipped);
					for statID,statVal in pairs(v.Bonus[i]) do
						local labelString = "  " .. GetStatPrefix(statID) .. statVal .. GetStatSuffix(statID) .. " " .. _TABLES.STATS[statID][LANGID];
						local lblBonus = NewWindowLabel(nil,builds_lstBonus:GetWidth(),16,0,0,labelString);
						lblBonus:SetFont(_FONTS[4]);
						lblBonus:SetForeColor(_COLORS[2]);
						if i<=setCount then lblBonus:SetForeColor(_COLORS[11]) end;
						builds_lstBonus:AddItem(lblBonus);
					end
				end
			end
		end
		local cItemContainer = NewItemContainer(builds_lstBonus:GetWidth(),10);
		builds_lstBonus:AddItem(cItemContainer);
	end
end


function GetSetCount(setList,setID)
	if setList == nil or setID == nil then return end;
	local count = 0;
	for k,v in pairs(setList) do
		if v == setID then count = count + 1 end;
	end
	return count;
end


function IsPartOfBuild(itemID,build)
	if itemID == nil or build == nil then return false end;
	for k,v in pairs(build) do
		if v == itemID then return true end;
	end
	return false;
end


function GetItemSet(itemID)
	if itemID == nil or _ITEMSDB[itemID] == nil or _ITEMSDB[itemID][15] == nil then return end;
	local _set = _ITEMSDB[itemID][15];
	local _output = {};
	if _set[1][LANGID] == nil or _set[1][LANGID] == "" then
		_output["Name"] = _set[1][1];
	else
		_output["Name"] = _set[1][LANGID];
	end
	if _set[2] ~= nil then _output["Pieces"] = _set[2] end;
	if _set[3] ~= nil then _output["Bonus"] = _set[3] end;
	return _output;
end


function UpdateBuildStats(buildID)
	if buildID == nil or _BUILDS[buildID] == nil then return end;
	ResetBuildStats();
	local _buildStats = GetTotalSetStats(_BUILDS[buildID]);
	if _buildStats[1]~=nil then builds_MoraleVal:SetText(Utils.comma_value(math.floor(_buildStats[1]))) end;
	if _buildStats[4]~=nil then builds_PowerVal:SetText(Utils.comma_value(math.floor(_buildStats[4]))) end;
	if _buildStats[30]~=nil then builds_ArmourVal:SetText(Utils.comma_value(math.floor(_buildStats[30]))) end;
	if _buildStats[7]~=nil then builds_MightVal:SetText(Utils.comma_value(math.floor(_buildStats[7]))) end;
	if _buildStats[8]~=nil then builds_AgilityVal:SetText(Utils.comma_value(math.floor(_buildStats[8]))) end;
	if _buildStats[9]~=nil then builds_VitalityVal:SetText(Utils.comma_value(math.floor(_buildStats[9]))) end;
	if _buildStats[10]~=nil then builds_WillVal:SetText(Utils.comma_value(math.floor(_buildStats[10]))) end;
	if _buildStats[11]~=nil then builds_FateVal:SetText(Utils.comma_value(math.floor(_buildStats[11]))) end;
	if _buildStats[12]~=nil then builds_CritVal:SetText(Utils.comma_value(math.floor(_buildStats[12]))) end;
	if _buildStats[14]~=nil then builds_PMastVal:SetText(Utils.comma_value(math.floor(_buildStats[14]))) end;
	if _buildStats[15]~=nil then builds_TMastVal:SetText(Utils.comma_value(math.floor(_buildStats[15]))) end;
	if _buildStats[19]~=nil then builds_BlockVal:SetText(Utils.comma_value(math.floor(_buildStats[19]))) end;
	if _buildStats[20]~=nil then builds_ParryVal:SetText(Utils.comma_value(math.floor(_buildStats[20]))) end;
	if _buildStats[21]~=nil then builds_EvadeVal:SetText(Utils.comma_value(math.floor(_buildStats[21]))) end;
	if _buildStats[25]~=nil then builds_PMitVal:SetText(Utils.comma_value(math.floor(_buildStats[25]))) end;
	if _buildStats[26]~=nil then builds_TMitVal:SetText(Utils.comma_value(math.floor(_buildStats[26]))) end;
end


function ResetBuildStats()
	builds_MoraleVal:SetText("0");
	builds_PowerVal:SetText("0");
	builds_ArmourVal:SetText("0");
	builds_MightVal:SetText("0");
	builds_AgilityVal:SetText("0");
	builds_VitalityVal:SetText("0");
	builds_WillVal:SetText("0");
	builds_FateVal:SetText("0");
	builds_CritVal:SetText("0");
	builds_PMastVal:SetText("0");
	builds_TMastVal:SetText("0");
	builds_BlockVal:SetText("0");
	builds_ParryVal:SetText("0");
	builds_EvadeVal:SetText("0");
	builds_PMitVal:SetText("0");
	builds_TMitVal:SetText("0");
end


function ClearSlotItems(slotNumber)
	if slotNumber == nil then
		for i=1, 18 do
			builds_cSlots[i]:SetItemInfo();
			builds_cSlots[i]:SetVisible(false);
			builds_cSlots[i].ItemID = 0;
		end
	else
		builds_cSlots[slotNumber]:SetItemInfo();
		builds_cSlots[slotNumber]:SetVisible(false);
		builds_cSlots[slotNumber].ItemID = 0;
	end
end
