
function DrawCompareBar()

	wCompareBar = Turbine.UI.Window();
	wCompareBar:SetHideF12(true);
	wCompareBar:SetCloseEsc(false);
	wCompareBar["Type"] = 0;
	wCompareBar["Slot"] = 0;

	back_CompareBarLeft = Turbine.UI.Control();
	back_CompareBarLeft:SetParent(wCompareBar);
	back_CompareBarLeft:SetSize(7,95);
	back_CompareBarLeft:SetPosition(0,0);
	back_CompareBarLeft:SetBackground(_IMAGES.COMPAREBAR.LEFT);
	back_CompareBarLeft:SetBlendMode(4);
	back_CompareBarLeft:SetMouseVisible(false);

	back_CompareBarMiddle = Turbine.UI.Control();
	back_CompareBarMiddle:SetParent(wCompareBar);
	back_CompareBarMiddle:SetSize(10,95);
	back_CompareBarMiddle:SetPosition(7,0);
	back_CompareBarMiddle:SetBackground(_IMAGES.COMPAREBAR.MIDDLE);
	back_CompareBarMiddle:SetBlendMode(4);
	back_CompareBarMiddle:SetMouseVisible(false);

	back_CompareBarRight = Turbine.UI.Control();
	back_CompareBarRight:SetParent(wCompareBar);
	back_CompareBarRight:SetSize(117,95);
	back_CompareBarRight:SetPosition(17,0);
	back_CompareBarRight:SetBackground(_IMAGES.COMPAREBAR.RIGHT);
	back_CompareBarRight:SetBlendMode(4);
	back_CompareBarRight:SetMouseVisible(false);

	compBar_btnClear = Turbine.UI.Lotro.Button();
	compBar_btnClear:SetParent(wCompareBar);
	compBar_btnClear:SetWidth(100);
	compBar_btnClear:SetText(_LABELS[4][LANGID]);

	compBar_btnClear.Click = function ()
		ClearCompareBar();
		HideCompareBar();
	end

	compBar_btnCompare = Turbine.UI.Lotro.Button();
	compBar_btnCompare:SetParent(wCompareBar);
	compBar_btnCompare:SetWidth(100);
	compBar_btnCompare:SetText(_LABELS[22][LANGID]);

	compBar_btnCompare.Click = function ()
		if GetEquipped() == nil then
			Utils.MessageBox(_LABELS[29][LANGID]);
		else
			PrepareForCompare();
			ClearCompareBar();
			HideCompareBar();
		end
	end

	compBar_cItemContainer = Turbine.UI.Control();
	compBar_cItemContainer:SetParent(wCompareBar);
	compBar_cItemContainer:SetBackColor(Turbine.UI.Color.Black);
	compBar_cItemContainer:SetSize(0,85);
	compBar_cItemContainer:SetPosition(5,5);

	UpdateCompareBar();

end


function PrepareForCompare()
	local BoxControls = compBar_cItemContainer:GetControls();
	local ControlCount = BoxControls:GetCount();
	local compareType = wCompareBar["Type"];	-- 0=nil	1=items		2=builds
	if compareType == 0 then return end;
	local compareSlot = wCompareBar["Slot"];
	local _compareT = {};
	local _equippedT = {};
	for i=1, ControlCount do
		local Item = BoxControls:Get(i);
		-- Check if item is flagged as equipped..
		if Item.Equipped == true then
			blEquipped = true;
			if compareType == 1 then
				local t = {};
				t[compareSlot] = Item.CompareID;
				if _ITEMSDB[Item.CompareID][1][LANGID] == nil or _ITEMSDB[Item.CompareID][1][LANGID] == "" then	-- If item name doesn't exist in the player's language then default to english
					t[19] = _ITEMSDB[Item.CompareID][1][1];
				else
					t[19] = _ITEMSDB[Item.CompareID][1][LANGID];
				end
				table.insert(_equippedT,t);
			else
				table.insert(_equippedT,_BUILDS[Item.CompareID]);
			end
		else
			if compareType == 1 then	-- item
				local t = {};
				t[compareSlot] = Item.CompareID;
				if _ITEMSDB[Item.CompareID][1][LANGID] == nil or _ITEMSDB[Item.CompareID][1][LANGID] == "" then	-- If item name doesn't exist in the player's language then default to english
					t[19] = _ITEMSDB[Item.CompareID][1][1];
				else
					t[19] = _ITEMSDB[Item.CompareID][1][LANGID];
				end
				table.insert(_compareT,	t);
			else	-- build
				table.insert(_compareT,_BUILDS[Item.CompareID]);
			end
		end
	end

	CompareItems(_equippedT,_compareT,compareType);
end


function UpdateCompareBar()
	wCompareBar:SetSize(5+compBar_cItemContainer:GetWidth()+10+compBar_btnClear:GetWidth()+5,5+compBar_cItemContainer:GetHeight()+5);
	wCompareBar:SetPosition((SCREENWIDTH/2)-(wCompareBar:GetWidth()/2),0);
	compBar_btnClear:SetPosition(wCompareBar:GetWidth()-compBar_btnClear:GetWidth()-5,wCompareBar:GetHeight()-compBar_btnClear:GetHeight()-5);
	compBar_btnCompare:SetPosition(wCompareBar:GetWidth()-compBar_btnCompare:GetWidth()-5,compBar_btnClear:GetTop()-compBar_btnCompare:GetHeight()-10);

	back_CompareBarRight:SetLeft(wCompareBar:GetWidth()-117);
	back_CompareBarMiddle:SetWidth(wCompareBar:GetWidth()-124);

	if compBar_cItemContainer:GetControls():GetCount() > 1 then
		compBar_btnCompare:SetEnabled(true);
	else
		compBar_btnCompare:SetEnabled(false);
	end
end


function RepositionCompareBarItems()
	local BoxControls = compBar_cItemContainer:GetControls();
	local ControlCount = BoxControls:GetCount();
	local totalWidth = 0;
	for i=1, ControlCount do
		local Item = BoxControls:Get(i);
		totalWidth = totalWidth + Item:GetWidth();
		if i > 1 then
			local previousItem = BoxControls:Get(i-1);
			Item:SetLeft(previousItem:GetLeft()+previousItem:GetWidth());
			Item:SetTop(previousItem:GetTop());
		else
			Item:SetPosition(0,0);
		end
	end
	compBar_cItemContainer:SetWidth(totalWidth);
	UpdateCompareBar();
end


function CheckDupliates(itemID)
	if itemID == nil then return false end;
	local blExists = false;
	local BoxControls = compBar_cItemContainer:GetControls();
	local ControlCount = BoxControls:GetCount();
	for i=1, ControlCount do
		local Item = BoxControls:Get(i);
		if Item.CompareID ~= nil and Item.CompareID == itemID then
			blExists = true;
			break;
		end
	end
	return blExists;
end


function CompareMaxReached()
	local maxReached = false;
	local BoxControls = compBar_cItemContainer:GetControls();
	local ControlCount = BoxControls:GetCount();
	if ControlCount >= SETTINGS.COMPAREMAX then maxReached = true end;
	return maxReached;
end


function Compare_GetEquippedItem(SlotID)
	if SlotID == nil then return end;
	local _matchingSlots = {};
	for k,v in ipairs (_TABLES.BUILDSLOTS) do
		if type(v.TYPE) == 'table' then
			for typeKey,typeID in pairs (v.TYPE) do
				if typeID == SlotID then table.insert(_matchingSlots,k) end;
			end
		else
			if v.TYPE == SlotID then table.insert(_matchingSlots,k) end;
		end
	end
	for k,v in ipairs(_matchingSlots) do
		if _BUILDS[1][v] ~= nil then AddToCompare(_BUILDS[1][v],1,true) end;
	end
end


function AddToCompare(itemID,itemType,equipped)	-- itemType (Build[2],Item[1]), itemID (Item ID or Build ID)
	if itemID == nil then return end;
	if equipped == nil then equipped = false end;
	if wCompareBar == nil then DrawCompareBar() end;
	-- itemType [1] = normal item;		[2] = build
	if itemType == nil then itemType = 1 end;

	-- iTEM CHECKS
	if wCompareBar["Type"] ~= itemType then -- prevents build vs item comparison
		ClearCompareBar();
		wCompareBar["Type"] = itemType;
	end

	if itemType == 1 then	-- prevents items from different slots being compared
		local itemSlot = _ITEMSDB[itemID][5];
		if wCompareBar["Slot"] == 0 then wCompareBar["Slot"] = itemSlot end;
		if wCompareBar["Slot"] ~= itemSlot then
			local sOutput = _TABLES.SLOT[wCompareBar["Slot"]][LANGID] .. " & " .. _TABLES.SLOT[itemSlot][LANGID];
			Utils.MessageBox(_LABELS[28][LANGID] .. ": " .. sOutput);
			return;
		end
		if equipped == false then Compare_GetEquippedItem(itemSlot) end;
	end

	if CheckDupliates(itemID) == true then	-- don't allow items to duplicate
		return;
	end

	if CompareMaxReached() == true then	-- don't allow anymore items
		Utils.MessageBox(_LABELS[30][LANGID]);
		return;
	end

	-- All checks complete, add item
	local controls = compBar_cItemContainer:GetControls();
	local compareItem = {};

	if itemType == 2 then  	-- Check if equipped is already added, if not then add it.
		if CheckDupliates(1) == false then
			controls:Add(CreateBarBuild(1));
		end
		compareItem = CreateBarBuild(itemID);
	else
		compareItem = CreateBarItem(itemID);
	end
	controls:Add(compareItem);
	if equipped == true then SetAsEquipped(compareItem) end;
	RepositionCompareBarItems();
	ShowCompareBar();
end


function RemoveFromCompare(item)
	if item == nil then return end;
	local controls = compBar_cItemContainer:GetControls();
	if controls:Contains(item) == true then controls:Remove(item) end;
	item = nil;
	RepositionCompareBarItems();
	if controls:GetCount() == 0 then HideCompareBar() end;
end


function ClearCompareBar()
	local BoxControls = compBar_cItemContainer:GetControls();
	BoxControls:Clear();
	RepositionCompareBarItems();
	wCompareBar["Type"] = 0;
	wCompareBar["Slot"] = 0;
end


function ShowCompareBar()
	if wCompareBar == nil then DrawCompareBar() end;
	wCompareBar:SetVisible(true);
	wCompareBar:Activate();
end


function HideCompareBar()
	wCompareBar["Type"] = 0;
	wCompareBar["Slot"] = 0;
	wCompareBar:Close();
end


function SetAsEquipped(control)
	if control == nil then return end;
	local BoxControls = compBar_cItemContainer:GetControls();
	local ControlCount = BoxControls:GetCount();
	for i=1, ControlCount do
		local Item = BoxControls:Get(i);
		if Item == control then
			Item:SetEquipped(true);
		else
			Item:SetEquipped(false);
		end
	end
end


function GetEquipped()
	local BoxControls = compBar_cItemContainer:GetControls();
	local ControlCount = BoxControls:GetCount();
	for i=1, ControlCount do
		local Item = BoxControls:Get(i);
		if Item.Equipped == true then
			return Item;
		end
	end
	return nil;
end


function CreateBarItem(itemID)

	if itemID == nil then return end;

	local itemHex = Utils.TO_HEX(itemID);
	local _itemInfo = _ITEMSDB[itemID];

	local cItemContainer = NewItemContainer(140,85);
	cItemContainer["CompareID"] = itemID;
	cItemContainer["Equipped"] = false;

	cItemContainer.MouseClick = function (sender,args)
		if args.Button == Turbine.UI.MouseButton.Right then

			local contextMenu = Turbine.UI.ContextMenu();
			local menuItems = contextMenu:GetItems();
			local cEquipped = Turbine.UI.MenuItem(_LABELS[13][LANGID]);
			local cRemove = Turbine.UI.MenuItem(_LABELS[19][LANGID]);

			cEquipped.Click = function()
				SetAsEquipped(cItemContainer);
			end

			cRemove.Click = function()
				RemoveFromCompare(cItemContainer);
			end

			menuItems:Add(cEquipped);
			menuItems:Add(cRemove);
			contextMenu:ShowMenu();
		end
	end

	local cEquippedBack = Turbine.UI.Control();
	cEquippedBack:SetParent(cItemContainer);
	cEquippedBack:SetSize(42,42);
	cEquippedBack:SetPosition((cItemContainer:GetWidth()/2)-(cEquippedBack:GetWidth()/2),1);
	cEquippedBack:SetBackground(_IMAGES.COMPARE_EQUIPPED);
	cEquippedBack:SetBlendMode(4);
	cEquippedBack:SetMouseVisible(false);
	cEquippedBack:SetVisible(false);

	-- ITEM INSPECT CONTROL ------------------------------------------------------------------------------------------------
	local cItemInspect = NewItemInfo(itemID);
	cItemInspect:SetParent(cItemContainer);
	cItemInspect:SetPosition((cItemContainer:GetWidth()/2)-(cItemInspect:GetWidth()/2)-1,3);

	local lblName = Turbine.UI.Label();
	lblName:SetParent(cItemContainer);
	lblName:SetSize(cItemContainer:GetWidth()-10,40);
	lblName:SetPosition(5,44);
	lblName:SetFont(_FONTS[4]);
	lblName:SetMouseVisible(false);
	lblName:SetForeColor(_QUALITYCOLORS[_itemInfo[4]]);
	lblName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	if _itemInfo[1][LANGID] == nil or _itemInfo[1][LANGID] == "" then	-- If item name doesn't exist in the player's language then default to english
		lblName:SetText(_itemInfo[1][1]);
	else
		lblName:SetText(_itemInfo[1][LANGID]);
	end

	cItemContainer["String"] = lblName:GetText();

	cItemContainer.SetEquipped = function (Sender,Value)
		if Value == nil then Value = false end;
		cEquippedBack:SetVisible(Value);
		cItemContainer.Equipped = Value;
	end

	return cItemContainer;

end

function CreateBarBuild(buildID)

	if buildID == nil then return end;
	if _BUILDS[buildID] == nil then return end;
	if _BUILDS[buildID][19] == nil then _BUILDS[buildID][19] = "" end;

	local cItemContainer = NewItemContainer(140,85);
	cItemContainer["CompareID"] = buildID;

	local cEquippedBack = Turbine.UI.Control();
	cEquippedBack:SetParent(cItemContainer);
	cEquippedBack:SetSize(42,42);
	cEquippedBack:SetPosition((cItemContainer:GetWidth()/2)-(cEquippedBack:GetWidth()/2),1);
	cEquippedBack:SetBackground(_IMAGES.COMPARE_EQUIPPED);
	cEquippedBack:SetBlendMode(4);
	cEquippedBack:SetMouseVisible(false);
	cEquippedBack:SetVisible(false);

	local cItemInspect = Turbine.UI.Control();
	cItemInspect:SetSize(32,32);
	cItemInspect:SetParent(cItemContainer);
	cItemInspect:SetBackground(_IMAGES.ICONBACK);
	cItemInspect:SetBlendMode(4);
	cItemInspect:SetPosition((cItemContainer:GetWidth()/2)-(cItemInspect:GetWidth()/2),6);

	local lblName = Turbine.UI.Label();
	lblName:SetParent(cItemContainer);
	lblName:SetSize(cItemContainer:GetWidth()-10,40);
	lblName:SetPosition(5,44);
	lblName:SetFont(_FONTS[4]);
	lblName:SetMouseVisible(false);
	lblName:SetForeColor(_QUALITYCOLORS[5]);
	lblName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblName:SetText(_BUILDS[buildID][19]);

	if buildID == 1 then
		cItemContainer["Equipped"] = true;
		cEquippedBack:SetVisible(true);
	else
		cItemContainer.MouseClick = function (sender,args)
			if args.Button == Turbine.UI.MouseButton.Right then

				local contextMenu = Turbine.UI.ContextMenu();
				local menuItems = contextMenu:GetItems();
				local cRemove = Turbine.UI.MenuItem(_LABELS[19][LANGID]);

				cRemove.Click = function()
					RemoveFromCompare(cItemContainer);
				end

				menuItems:Add(cRemove);
				contextMenu:ShowMenu();
			end
		end
	end

	return cItemContainer;
end
