
function DrawCompareWin()

	wCompareWin = Turbine.UI.Lotro.Window();
	wCompareWin:SetMinimumSize(636,735);
	wCompareWin:SetSize(SCREENWIDTH*0.7,735);
	wCompareWin:SetPosition((SCREENWIDTH/2)-(wCompareWin:GetWidth()/2),(SCREENHEIGHT/2)-(wCompareWin:GetHeight()/2));
	wCompareWin:SetText(_LABELS[26][LANGID]);
	wCompareWin:SetHideF12(true);
	wCompareWin:SetCloseEsc(false);

	compare_lstClasses = Turbine.UI.ListBox();
	compare_lstClasses:SetParent(wCompareWin);
	compare_lstClasses:SetSize(616,64);
	compare_lstClasses:SetPosition((wCompareWin:GetWidth()/2)-(compare_lstClasses:GetWidth()/2),50);
	compare_lstClasses:SetOrientation(Turbine.UI.Orientation.Horizontal);
	compare_lstClasses["Selected"] = 0;

	local _classes = {};
	for k,v in pairs (_TABLES.CLASS) do
		table.insert(_classes,{["Name"]=v[LANGID];["ID"]=k;});
	end
	table.sort(_classes,function(a,b) return a.Name<b.Name end);

	for k,v in ipairs (_classes) do

		local cItemContainer = Turbine.UI.Control();
		cItemContainer:SetSize(69,64);
		cItemContainer["ClassID"] = v.ID;
		cItemContainer:SetToolTip(v.Name);

		local classButton = Turbine.UI.Control();
		classButton:SetParent(cItemContainer);
		classButton:SetSize(64,64);
		classButton:SetMouseVisible(false);
		classButton:SetBlendMode(4);
		classButton:SetBackground(_IMAGES.CLASSBUTTON_NORMAL);

		cItemContainer["Button"] = classButton;

		local classIcon = Turbine.UI.Control();
		classIcon:SetParent(classButton);
		classIcon:SetSize(48,48);
		classIcon:SetPosition(8,8);
		classIcon:SetMouseVisible(false);
		classIcon:SetBackground(_IMAGES.CLASS[v.ID]);
		classIcon:SetBlendMode(4);

		if v.ID == PLAYERCLASS then
			classButton:SetBackground(_IMAGES.CLASSBUTTON_OVER);
			compare_lstClasses.Selected = cItemContainer;
		end

		local itemEnter = function ()
			classButton:SetBackground(_IMAGES.CLASSBUTTON_OVER);
		end
		AddCallback(cItemContainer,"MouseEnter",itemEnter);

		local itemLeave = function ()
			if compare_lstClasses.Selected ~= cItemContainer then
				classButton:SetBackground(_IMAGES.CLASSBUTTON_NORMAL);
			end
		end
		AddCallback(cItemContainer,"MouseLeave",itemLeave);

		local itemClick = function ()
			compare_lstClasses.Selected.Button:SetBackground(_IMAGES.CLASSBUTTON_NORMAL);
			compare_lstClasses.Selected = cItemContainer;
			SwitchCompareClass(v.ID);
		end
		AddCallback(cItemContainer,"MouseClick",itemClick);

		compare_lstClasses:AddItem(cItemContainer);

	end

	compare_lstBase = Turbine.UI.ListBox();
	compare_lstBase:SetParent(wCompareWin);
	compare_lstBase:SetPosition(20,compare_lstClasses:GetTop()+compare_lstClasses:GetHeight()+30);
	compare_lstBase:SetSize(320,556);
	--compare_lstBase:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1));

	compare_lstItems = Turbine.UI.ListBox();
	compare_lstItems:SetParent(wCompareWin);
	compare_lstItems:SetPosition(compare_lstBase:GetLeft()+compare_lstBase:GetWidth(),compare_lstBase:GetTop());
	compare_lstItems:SetSize(wCompareWin:GetWidth()-20-compare_lstItems:GetLeft(),compare_lstBase:GetHeight());
	compare_lstItems:SetOrientation(Turbine.UI.Orientation.Horizontal);
	--compare_lstItems:SetBackColor(Turbine.UI.Color(0.1,0.1,0.1));

	compare_sbItems = Turbine.UI.Lotro.ScrollBar();
	compare_sbItems:SetParent(wCompareWin);
	compare_sbItems:SetOrientation(Turbine.UI.Orientation.Horizontal);
	compare_sbItems:SetSize(compare_lstItems:GetWidth(),12);
	compare_sbItems:SetPosition(compare_lstItems:GetLeft(),compare_lstItems:GetTop()+compare_lstItems:GetHeight()+1);
	compare_sbItems:SetVisible(false);
	compare_lstItems:SetHorizontalScrollBar(compare_sbItems);

end

--[[
function SwitchCompareClass(classID)
	if classID == nil then return end;

	CompareItems(_equippedItem,_itemTable,compareType);

end
--]]

function FillBaseList(_itemTable,compareType,classOverride)
	if _itemTable == nil then return end;

	local function GetBaseControl(statName,equippedValue,statValue,width,height,backColor)
		if width == nil then width = compare_lstBase:GetWidth() end;
		if height == nil then height = 16 end;
		if statValue == nil then statValue = 0 end;
		if backColor == nil then backColor = Turbine.UI.Color(0,0,0) end;

		if equippedValue == nil then equippedValue = 0 end;

		if type(equippedValue) == 'number' then equippedValue = math.floor(equippedValue) end;

		local cItemContainer = Turbine.UI.Control();
		cItemContainer:SetSize(width,height);
		cItemContainer:SetBackColor(_COLORS[9]);

		local lblStat = Turbine.UI.Label();
		lblStat:SetParent(cItemContainer);
		lblStat:SetSize(width*0.5,height);
		lblStat:SetPosition(0,0);
		lblStat:SetFont(_FONTS[4]);
		lblStat:SetBackColor(backColor);
		lblStat:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		lblStat:SetText(" " .. statName);

		local lblEquipped = Turbine.UI.Label();
		lblEquipped:SetParent(cItemContainer);
		lblEquipped:SetSize(width*0.25,height);
		lblEquipped:SetPosition(lblStat:GetLeft()+lblStat:GetWidth(),0);
		lblEquipped:SetFont(_FONTS[4]);
		lblEquipped:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		lblEquipped:SetBackColor(backColor);
		lblEquipped:SetText(Utils.comma_value(equippedValue));

		local lblValue = Turbine.UI.Label();
		lblValue:SetParent(cItemContainer);
		lblValue:SetSize((width*0.25)-1,height);
		lblValue:SetPosition(lblEquipped:GetLeft()+lblEquipped:GetWidth(),0);
		lblValue:SetFont(_FONTS[4]);
		lblValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		lblValue:SetBackColor(backColor);
		lblValue:SetText(Utils.comma_value(statValue));

		return cItemContainer;
	end

	compare_lstBase:ClearItems();

	local itemName, itemID = GetSingleItem(_itemTable); -- itemID returned equals 0 if build is used
	compare_lstBase:AddItem(CreateCompareHeader(itemName,itemID,compare_lstBase:GetWidth(),nil,true,compareType));
	compare_lstBase:AddItem(GetBaseControl("",_LABELS[32][LANGID],_LABELS[31][LANGID],nil,26,Turbine.UI.Color.Navy));

	local _totalBuildStats = GetTotalSetStats(_itemTable,classOverride);

	for i=1, 26 do

		if i%2 == 0 then
			compare_lstBase:AddItem(GetBaseControl(_TABLES.STATS[i][LANGID],_totalBuildStats[i],_PLAYERSTATS[i],nil,nil,_COLORS[8]));
		else
			compare_lstBase:AddItem(GetBaseControl(_TABLES.STATS[i][LANGID],_totalBuildStats[i],_PLAYERSTATS[i]));
		end
	end

	compare_lstBase:AddItem(GetBaseControl(_LABELS[12][LANGID],_totalBuildStats[30],_PLAYERSTATS[30]));
end


function FillItemsList(_itemTable,_equippedItem,compareType,classOverride)
	if _itemTable == nil then return end;
	if _equippedItem == nil then _equippedItem = {} end;

	local function GetBaseControl(label1,label2,label3,label4,width,height,backColor,toolTip)
		if width == nil then width = 260 end;
		if height == nil then height = 16 end;
		if backColor == nil then backColor = Turbine.UI.Color(0,0,0) end;

		local cItemContainer = Turbine.UI.Control();
		cItemContainer:SetSize(width,height);
		cItemContainer:SetBackColor(_COLORS[9]);

		if toolTip ~= nil then
			cItemContainer:SetToolTip(toolTip);
		end

		local lbl1 = Turbine.UI.Label();
		lbl1:SetParent(cItemContainer);
		lbl1:SetSize(width*0.28,height);
		lbl1:SetPosition(0,0);
		lbl1:SetFont(_FONTS[4]);
		lbl1:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		lbl1:SetBackColor(backColor);
		lbl1:SetMouseVisible(false);
		lbl1:SetText(Utils.comma_value(label1));

		local lbl2 = Turbine.UI.Label();
		lbl2:SetParent(cItemContainer);
		lbl2:SetSize(width*0.28,height);
		lbl2:SetPosition(lbl1:GetLeft()+lbl1:GetWidth(),0);
		lbl2:SetFont(_FONTS[4]);
		lbl2:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		lbl2:SetBackColor(backColor);
		lbl2:SetMouseVisible(false);
		lbl2:SetText(Utils.comma_value(label2));

		local lbl3 = Turbine.UI.Label();
		lbl3:SetParent(cItemContainer);
		lbl3:SetSize(width*0.25,height);
		lbl3:SetPosition(lbl2:GetLeft()+lbl2:GetWidth(),0);
		lbl3:SetFont(_FONTS[4]);
		lbl3:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		lbl3:SetBackColor(backColor);
		lbl3:SetMouseVisible(false);
		lbl3:SetText(Utils.comma_value(label3));

		local lbl4 = Turbine.UI.Label();
		lbl4:SetParent(cItemContainer);
		lbl4:SetSize((width-lbl3:GetLeft()-lbl3:GetWidth())-1,height);
		lbl4:SetPosition(lbl3:GetLeft()+lbl3:GetWidth(),0);
		lbl4:SetFont(_FONTS[4]);
		lbl4:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		lbl4:SetBackColor(backColor);
		lbl4:SetMouseVisible(false);
		lbl4:SetText(Utils.comma_value(label4));

		if type(label3) == 'number' and label3 < 0 then
			lbl3:SetForeColor(_COLORS[10]);
			lbl4:SetForeColor(_COLORS[10]);
		elseif type(label3) == 'number' and label3 > 0 then
			lbl3:SetForeColor(_COLORS[11]);
			lbl4:SetForeColor(_COLORS[11]);
		end

		return cItemContainer;
	end

	compare_lstItems:ClearItems();

	for k,v in pairs (_itemTable) do -- loop though all items to compare

		if type (v) == 'table' then

			local cItemContainer = Turbine.UI.ListBox();
			cItemContainer:SetSize(260,compare_lstItems:GetHeight());

			local itemName, itemID = GetSingleItem(v); -- itemID returned equals 0 if build is used
			cItemContainer:AddItem(CreateCompareHeader(itemName,itemID,nil,nil,nil,compareType));

			cItemContainer:AddItem(GetBaseControl(_LABELS[32][LANGID],_LABELS[33][LANGID],_LABELS[34][LANGID],"%",cItemContainer:GetWidth(),26,Turbine.UI.Color.Navy));

			local _totalBuildStats = GetTotalSetStats(v,classOverride);

			for i=1,26 do
				local backColor = Turbine.UI.Color(0,0,0);
				if i%2 == 0 then backColor = _COLORS[8] end;

				local _stats = CalculateStats(_PLAYERSTATS[i],_equippedItem[i],_totalBuildStats[i]);

				if _totalBuildStats[i] == nil then
					cItemContainer:AddItem(GetBaseControl(0,_stats.Total,_stats.Var,_stats.Percent,cItemContainer:GetWidth(),nil,backColor,_TABLES.STATS[i][LANGID]));
				else
					cItemContainer:AddItem(GetBaseControl(math.floor(_totalBuildStats[i]),_stats.Total,_stats.Var,_stats.Percent,cItemContainer:GetWidth(),nil,backColor,_TABLES.STATS[i][LANGID]));
				end
			end

			local _stats = CalculateStats(_PLAYERSTATS[30],_equippedItem[30],_totalBuildStats[30]);

			if _totalBuildStats[i] == nil then
				cItemContainer:AddItem(GetBaseControl(0,_stats.Total,_stats.Var,_stats.Percent,cItemContainer:GetWidth(),nil,backColor,_LABELS[12][LANGID]));
			else
				cItemContainer:AddItem(GetBaseControl(math.floor(_totalBuildStats[30]),_stats.Total,_stats.Var,_stats.Percent,cItemContainer:GetWidth(),nil,backColor,_LABELS[12][LANGID]));
			end

			compare_lstItems:AddItem(cItemContainer);

		end
	end
end


function CreateCompareHeader(itemName,itemID,width,height,equipped,compareType)

	if itemName == nil or itemID == nil then return end;
	if width == nil then width = 260 end;
	if height == nil then height = 95 end;
	if equipped == nil then equipped = false end;
	if compareType == nil then compareType = 1 end;

	local itemHex = Utils.TO_HEX(itemID);
	local cItemContainer = NewItemContainer(width,height);

	if equipped == true then
		local cEquipped = Turbine.UI.Control();
		cEquipped:SetParent(cItemContainer);
		cEquipped:SetSize(42,42);
		cEquipped:SetPosition((cItemContainer:GetWidth()/2)+1-(cEquipped:GetWidth()/2),8);
		cEquipped:SetBackground(_IMAGES.COMPARE_EQUIPPED);
		cEquipped:SetBlendMode(4);
	else
		local cRemove = Utils.Button();
		cRemove:SetParent(cItemContainer);
		cRemove:SetSize(20,20);
		cRemove:SetPosition(cItemContainer:GetWidth()-cRemove:GetWidth()-10,10);
		cRemove:SetImageNormal(_IMAGES.BUTTONS.REMOVE.NORMAL);
		cRemove:SetImageOver(_IMAGES.BUTTONS.REMOVE.OVER);
		cRemove:SetToolTip(_LABELS[19][LANGID]);

		cRemove.Click = function ()
			RemoveItemFromGrid(cItemContainer:GetParent());
		end

		if compareType == 1 then
			local cBookmark = Utils.Button();
			cBookmark:SetParent(cItemContainer);
			cBookmark:SetSize(20,20);
			cBookmark:SetPosition(cRemove:GetLeft()-5-cBookmark:GetWidth(),cRemove:GetTop());
			cBookmark:SetToolTip(_TOOLTIPS[13][LANGID]);

			Includes.UpdateBookmarkIcon(cBookmark,itemID);

			cBookmark.Click = function ()
				Includes.UpdateBookmark(cBookmark,itemID);
			end
		end
	end

	local lblName = Turbine.UI.Label();
	lblName:SetParent(cItemContainer);
	lblName:SetSize(cItemContainer:GetWidth()-10,30);
	lblName:SetPosition(5,56);
	lblName:SetFont(_FONTS[3]);
	lblName:SetMouseVisible(false);
	lblName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblName:SetText(itemName);

	if compareType == 1 then
		local cItemInspect = NewItemInfo(itemID);
		cItemInspect:SetParent(cItemContainer);
		cItemInspect:SetPosition((cItemContainer:GetWidth()/2)-(cItemInspect:GetWidth()/2),10);
		if itemID ~= 0 then
			lblName:SetForeColor(_QUALITYCOLORS[_ITEMSDB[itemID][4]]);
		end
	else
		local cItemInspect = Turbine.UI.Control();
		cItemInspect:SetSize(32,32);
		cItemInspect:SetParent(cItemContainer);
		cItemInspect:SetBackground(_IMAGES.ICONBACK);
		cItemInspect:SetBlendMode(4);
		cItemInspect:SetPosition((cItemContainer:GetWidth()/2)-(cItemInspect:GetWidth()/2)+2,13);
		lblName:SetForeColor(_QUALITYCOLORS[5]);
	end

	return cItemContainer;
end


function RemoveItemFromGrid(item)

	if item == nil then return end;
	compare_lstItems:RemoveItem(item);
	ResizeRepositionCompare();

end


function CalculateStats(playerStat,equippedStat,itemStat)
	if playerStat == nil then playerStat = 0 end;
	if equippedStat == nil then equippedStat = 0 end;
	if itemStat == nil then itemStat = 0 end;
	local percent = 0;

	local newTotal = math.floor((playerStat - equippedStat) + itemStat);
	local var = math.floor(newTotal - playerStat);

	if playerStat == 0 then
		percent = 0;
	else
		percent = Utils.RoundNumber(((newTotal/playerStat)-1)*100,1);
	end

	if percent ~= 0 then percent = tostring(percent .. "%") end;

	return {["Total"]=newTotal;["Var"]=var;["Percent"]=percent;};
end


function CompareItems(_equippedItem,_itemTable,compareType)
	if _equippedItem == nil or type(_equippedItem) ~= 'table' then return end;
	if _itemTable == nil or type(_itemTable) ~= 'table' then return end;
	if compareType == nil then compareType = 1 end;
	if wCompareWin == nil then DrawCompareWin() end;
	_PLAYERSTATS = GetPlayerStats();
	local _totalStatsEquipped = GetTotalSetStats(_equippedItem[1],classOverride);
	FillBaseList(_equippedItem[1],compareType);
	FillItemsList(_itemTable,_totalStatsEquipped,compareType);
	ResizeRepositionCompare();
	wCompareWin:SetVisible(true);
	wCompareWin:Activate();

	function SwitchCompareClass(classID)
		if classID == nil then return end;
		local _totalStatsEquipped = GetTotalSetStats(_equippedItem[1],classID);
		FillBaseList(_equippedItem[1],compareType,classID);
		FillItemsList(_itemTable,_totalStatsEquipped,compareType,classID);
		ResizeRepositionCompare();
	end
end


function ResizeRepositionCompare()	-- resizes the window based on number of items compared. If too big then scrollbar is used
	local itemsWidth = 0;
	local maxWidth = SCREENWIDTH*0.95;
	local listsWidth = compare_lstBase:GetWidth()+40; 	-- 40=allowance each side of grid view
	for i=1, compare_lstItems:GetItemCount() do
		itemsWidth = itemsWidth + compare_lstItems:GetItem(i):GetWidth();
	end
	if (itemsWidth+listsWidth) <= maxWidth then
		compare_lstItems:SetWidth(itemsWidth);
		wCompareWin:SetWidth(itemsWidth+listsWidth);
	else
		compare_lstItems:SetWidth(maxWidth-listsWidth);
		wCompareWin:SetWidth(maxWidth);
	end
	compare_sbItems:SetWidth(compare_lstItems:GetWidth());
	wCompareWin:SetLeft((SCREENWIDTH/2)-(wCompareWin:GetWidth()/2));
	compare_lstClasses:SetLeft((wCompareWin:GetWidth()/2)-(compare_lstClasses:GetWidth()/2));
end


function GetSingleItem(_buildTable)
	local itemID = 0;
	local itemCount = 0;
	for i=1,18 do
		if _buildTable[i] ~= nil then
			itemCount = itemCount + 1;
			itemID = _buildTable[i];
		end
	end
	if itemCount > 1 then itemID = 0 end;
	return _buildTable[19],itemID;
end



function GetTotalSetStats(_setItems,classOverride)
	if _setItems == nil or type (_setItems) ~= 'table' then _setItems = {} end;
	local _totalBuildStats = {};
	for id=1,18 do	-- loop for build slots
		if _setItems[id] ~= nil and _ITEMSDB[_setItems[id]] ~= nil then
			local _itemStats = GetItemStats(_setItems[id]);
			-- loop through all the stats to see if included and add to totals table
			for statID,statVal in pairs (_itemStats) do
				if _totalBuildStats[statID] == nil then
					_totalBuildStats[statID] = statVal;
				else
					_totalBuildStats[statID] = _totalBuildStats[statID] + statVal;
				end
			end
			-- Check for armour
			if _ITEMSDB[_setItems[id]][8] ~= nil then
				if _totalBuildStats[30] == nil then
					_totalBuildStats[30] = _ITEMSDB[_setItems[id]][8];
				else
					_totalBuildStats[30] = _totalBuildStats[30] + _ITEMSDB[_setItems[id]][8];
				end
			end
		end
	end

	local _setIDs,_buildSets = GetSetTables(_setItems);
	for k,v in ipairs (_buildSets) do
		local setCount = GetSetCount(_setIDs,k);
		if type(v.Bonus) == 'table' then
			for i=1, setCount do
				if v.Bonus[i] ~= nil and type(v.Bonus[i]) == 'table' then
					for statID,statVal in pairs(v.Bonus[i]) do
						if _totalBuildStats[statID] == nil then
							_totalBuildStats[statID] = statVal;
						else
							_totalBuildStats[statID] = _totalBuildStats[statID] + statVal;
						end
					end
				end
			end
		end
	end

	local _expandedTable = ExpandSecondaryStats(_totalBuildStats,classOverride);	-- Handle secondary stats
	return _expandedTable;
end


function ExpandSecondaryStats(_setTable,classOverride)
	if classOverride == nil then classOverride = PLAYERCLASS end;
	if _setTable == nil or type (_setTable) ~= 'table' then return {} end;
	for k,v in pairs(_STATSDB[classOverride]) do	-- loops through all the stats in the table for that class
		if _setTable[k] ~= nil then		-- checks for stat matches in the set stats
			for statID,statVal in pairs (v) do		-- loops through the secondary stats in the stat table
				if _setTable[statID] == nil then
					_setTable[statID] = _setTable[k]*statVal;	-- calculates new totals
				else
					_setTable[statID] = _setTable[statID] + (_setTable[k]*statVal);		-- calculates new totals
				end
			end
		end
	end
	return _setTable;
end


function GetItemStats(itemID)
	if itemID == nil then return end;
	local _stats = {};
	if _ITEMSDB[itemID] ~= nil and _ITEMSDB[itemID][6] ~= nil and type( _ITEMSDB[itemID][6] ) == 'table' then
		_stats = _ITEMSDB[itemID][6];
	end
	return _stats;
end


function DumpPlayerStats()
	local s = "";
	for k,v in pairs(Turbine.Gameplay.Attributes.FreePeopleAttributes) do
		local sOut = tostring(k) .. " = ";
		local valFunc = loadstring("return _G.GaluhadPlugins.Tulkas.PLAYERCHAR:GetAttributes():"..k.."()");
		local val = valFunc();
		sOut = sOut .. tostring(val);
		s = s .. sOut .. "\n";
	end
	print(s);
end


function GetPlayerStats()

	local playerAtts = PLAYERCHAR:GetAttributes();
	local _stats =
	{
	[1] =  math.floor(PLAYERCHAR:GetMaxMorale()); --"Maximum Morale";
	[2] =  math.floor(60*playerAtts:GetInCombatMoraleRegeneration()); --"in-Combat Morale Regen";
	[3] =  math.floor(60*playerAtts:GetOutOfCombatMoraleRegeneration()); --"non-Combat Morale Regen";

	[4] =  math.floor(PLAYERCHAR:GetMaxPower()); --"Maximum Power";
	[5] =  math.floor(60*playerAtts:GetInCombatPowerRegeneration()); --"in-Combat Power Regen";
	[6] =  math.floor(60*playerAtts:GetOutOfCombatPowerRegeneration()); --"non-Combat Power Regen";

	[7] =  math.floor(playerAtts:GetMight()); --"Might";
	[8] =  math.floor(playerAtts:GetAgility()); --"Agility";
	[9] =  math.floor(playerAtts:GetVitality()); --"Vitality";
	[10] = math.floor(playerAtts:GetWill()); --"Will";
	[11] = math.floor(playerAtts:GetFate()); --"Fate";

	[12] = math.floor(playerAtts:GetMeleeCriticalHitChance()); --"Critical Rating";
	[13] = math.floor(playerAtts:GetFinesse()); --"Finesse Rating";
	[14] = math.floor(playerAtts:GetMeleeDamage()); --"Physical Mastery Rating";
	[15] = math.floor(playerAtts:GetTacticalDamage()); --"Tactical Mastery Rating";

	[16] = math.floor(playerAtts:GetBaseResistance()); --"Resistance Rating";
	[17] = math.floor(playerAtts:GetBaseCriticalHitAvoidance()); --"Critical Defence";
	[18] = math.floor(playerAtts:GetIncomingHealing()); --"Incoming Healing Rating";

	[19] = math.floor(playerAtts:GetBlock()); --"Block Rating";
	[20] = math.floor(playerAtts:GetParry()); --"Parry Rating";
	[21] = math.floor(playerAtts:GetEvade()); --"Evade Rating";

	[22] = math.floor(playerAtts:GetMeleeDefence()); --"Melee Defence";
	[23] = math.floor(playerAtts:GetRangeDefence()); --"Ranged Defence";
	[24] = math.floor(playerAtts:GetTacticalDefence()); --"Tactical Defence";

	[25] = math.floor(playerAtts:GetCommonMitigation()); --"Physical Mitigation";
	[26] = math.floor(playerAtts:GetTacticalMitigation()); --"Tactical Mitigation";

	[27] =  0; --"Audacity";
	[28] =  0; --"Stealth Level";
	[29] =  0; --"Tactical Critical Multiplier";

	[30] = math.floor(playerAtts:GetArmor()); -- Armour (Not used as a stat value in items)
	};

	return _stats;
end

