
function DrawEditSetWin()

	wEditSetWin = Turbine.UI.Lotro.Window();
	wEditSetWin:SetSize(312,550);
	wEditSetWin:SetPosition((SCREENWIDTH/2)-(wEditSetWin:GetWidth()/2),(SCREENHEIGHT/2)-(wEditSetWin:GetHeight()/2));
	wEditSetWin:SetText(_LABELS[77][LANGID]);
	wEditSetWin:SetVisible(false);
	wEditSetWin:SetHideF12(true);
	wEditSetWin:SetCloseEsc(false);

	back_EditSet = Turbine.UI.Control();
	back_EditSet:SetParent(wEditSetWin);
	back_EditSet:SetSize(312,550);
	back_EditSet:SetPosition(0,-3);
	back_EditSet:SetBackground(_IMAGES.BACKGROUNDS.SETS_BACK);
	back_EditSet:SetBlendMode(4);
	back_EditSet:SetMouseVisible(false);

	set_lblName = NewWindowLabel(wEditSetWin,252,18,30,50,_TABLES.SETINFO[1][LANGID]..":");
	set_txtName = NewWindowTextBox(wEditSetWin,252,22,30,set_lblName:GetTop()+set_lblName:GetHeight()+2);

	set_lblPieces = NewWindowLabel(wEditSetWin,252,18,30,set_txtName:GetTop()+set_txtName:GetHeight()+17,_TABLES.SETINFO[2][LANGID]..":");
	set_lstItemHolder = Turbine.UI.ListBox();
	set_lstItemHolder:SetParent(wEditSetWin);
	set_lstItemHolder:SetSize(252,47);
	set_lstItemHolder:SetPosition(30,set_lblPieces:GetTop()+set_lblPieces:GetHeight()+5);
	set_lstItemHolder:SetOrientation(Turbine.UI.Orientation.Horizontal);
	set_sbItemHolder = NewScrollBar(set_lstItemHolder,"horizontal",wEditSetWin);

	set_btnAddPiece = Turbine.UI.Lotro.Button();
	set_btnAddPiece:SetParent(wEditSetWin);
	set_btnAddPiece:SetWidth(20);
	set_btnAddPiece:SetPosition(set_lstItemHolder:GetLeft()+set_lstItemHolder:GetWidth()-set_btnAddPiece:GetWidth(),set_lstItemHolder:GetTop()-25);
	set_btnAddPiece:SetToolTip(_LABELS[82][LANGID]);
	set_btnAddPiece:SetText("+");

	set_btnAddPiece.Click = function ()
		set_LookForNewPiece();
	end

	set_lblBonus = NewWindowLabel(wEditSetWin,252,18,30,set_lstItemHolder:GetTop()+set_lstItemHolder:GetHeight()+25,_TABLES.SETINFO[3][LANGID]..":");
	set_lstBonus = Turbine.UI.ListBox();
	set_lstBonus:SetParent(wEditSetWin);
	set_lstBonus:SetSize(242,260);
	set_lstBonus:SetPosition(30,set_lblBonus:GetTop()+set_lblBonus:GetHeight()+2);
	set_sbItemHolder = NewScrollBar(set_lstBonus,"vertical",wEditSetWin);

	set_btnAddBonus = Turbine.UI.Lotro.Button();
	set_btnAddBonus:SetParent(wEditSetWin);
	set_btnAddBonus:SetWidth(20);
	set_btnAddBonus:SetPosition(set_btnAddPiece:GetLeft(),set_lstBonus:GetTop()-25);
	set_btnAddBonus:SetToolTip(_LABELS[80][LANGID]);
	set_btnAddBonus:SetText("+");

	set_btnAddBonus.Click = function ()
		set_popupBonus();
	end

	set_btnCancel = Turbine.UI.Lotro.Button();
	set_btnCancel:SetParent(wEditSetWin);
	set_btnCancel:SetWidth(80);
	set_btnCancel:SetPosition(wEditSetWin:GetWidth()-30-set_btnCancel:GetWidth(),set_lstBonus:GetTop()+set_lstBonus:GetHeight()+20);
	set_btnCancel:SetText(_LABELS[55][LANGID]);

	set_btnCancel.Click = function()
		set_Clear();
		wEditSetWin:Close();
	end

	set_btnSave = Turbine.UI.Lotro.Button();
	set_btnSave:SetParent(wEditSetWin);
	set_btnSave:SetWidth(80);
	set_btnSave:SetPosition(set_btnCancel:GetLeft()-10-set_btnCancel:GetWidth(),set_btnCancel:GetTop());
	set_btnSave:SetText(_LABELS[59][LANGID]);

	set_btnSave.Click = function()
		set_Save();
	end

	-- Window Events --

end


function set_Clear()
	set_lstItemHolder:ClearItems();
	set_lstBonus:ClearItems();
	set_txtName:SetText("");
end


function set_Save()
	-- Check set name and pieces >= 2
	local _warn = {};

	if set_txtName:GetText()=="" then table.insert(_warn,_TABLES.SETINFO[1][LANGID]) end;
	if set_lstItemHolder:GetItemCount()<2 then table.insert(_warn,_TABLES.SETINFO[2][LANGID]) end;

	if #_warn > 0 then
		Utils.MessageBox(_LABELS[65][LANGID]..": "..table.concat(_warn,", "));
		return;
	end

	local _itemIDs = {};
	for i=1, set_lstItemHolder:GetItemCount() do
		table.insert(_itemIDs,set_lstItemHolder:GetItem(i).ItemID);
	end

	for k,v in ipairs(_itemIDs) do
		_ITEMS[v] = Utils.deepcopy(_ITEMSDB[v]);
		_ITEMS[v][15] = {};
		_ITEMS[v][15][1]={[1]="";[2]="";[3]="";[4]="";};
		_ITEMS[v][15][1][LANGID] = set_txtName:GetText();
		_ITEMS[v][15][2] = Utils.deepcopy(_itemIDs);

		if set_lstBonus:GetItemCount() > 0 then
			_ITEMS[v][15][3] = {};
			for i=1, set_lstBonus:GetItemCount() do
				local bonus = set_lstBonus:GetItem(i);
				if _ITEMS[v][15][3][bonus.PiecesNeeded] == nil then _ITEMS[v][15][3][bonus.PiecesNeeded] = {} end;
				_ITEMS[v][15][3][bonus.PiecesNeeded][tonumber(bonus.StatID)] = tonumber(bonus.StatVal);
			end
		end

		_ITEMSDB[v] = Utils.deepcopy(_ITEMS[v]);
	end

	if wEditItemWin ~= nil then RefreshSavedList() end;
	PrepareResults(_itemIDs);

	set_Clear();
	wEditSetWin:Close();
end


function set_EditSet(...)
	if ... == nil then return end;
	if wEditSetWin == nil then DrawEditSetWin() end;

	local args = ...;

	if type(args)=='table' then	-- Edit set rather than add to
		set_Clear();
	end

	if type(args)=='number' then
		args = {args};
	end

	if type(args)=='table' then
		if _ITEMSDB[args[1]][15]~= nil then
			if _ITEMSDB[args[1]][15][1][LANGID] ~= nil and _ITEMSDB[args[1]][15][1][LANGID] ~= "" then
				set_txtName:SetText(_ITEMSDB[args[1]][15][1][LANGID]);
			else
				set_txtName:SetText(_ITEMSDB[args[1]][15][1][1]);
			end

			if _ITEMSDB[args[1]][15][3] ~= nil and type(_ITEMSDB[args[1]][15][3])=='table' then
				for k, v in pairs(_ITEMSDB[args[1]][15][3]) do
					if type(v)=='table' then
						for statID,statVal in pairs (v) do
							set_AddBonus(k,statID,statVal);
						end
					end
				end
			end
		end

		for k,v in pairs(args) do
			set_AddItemControl(v);
		end
	end

	wEditSetWin:SetVisible(true);
	wEditSetWin:Activate();
end


function set_AddItemControl(itemID)
	if itemID == nil then return end;

	local cItemContainer = NewItemContainer(41,set_lstItemHolder:GetHeight());
	cItemContainer["ItemID"] = itemID;

	local cItemInspect = NewItemInfo(itemID);
	cItemInspect:SetParent(cItemContainer);
	cItemInspect:SetPosition(5,5);

	cItemInspect.MouseClick = function (Sender,Args)
		if cItemInspect:IsControlKeyDown() == false and Args.Button == Turbine.UI.MouseButton.Right then
			local contextMenu = Turbine.UI.ContextMenu();
			local menuItems = contextMenu:GetItems();

			local cRemove = Turbine.UI.MenuItem(_LABELS[19][LANGID]);
			cRemove.Click = function()
				set_lstItemHolder:RemoveItem(cItemContainer);
			end
			menuItems:Add(cRemove);
			contextMenu:ShowMenu();
		end
	end

	set_lstItemHolder:AddItem(cItemContainer);
end


function set_LookForNewPiece()
	if wSearchWin == nil then DrawSearchWin() end;
	wSearchWin:SetVisible(true);
	wSearchWin:Activate();
end


function set_popupBonus()
	Includes.DisplayBonusPopup();
end


function set_AddBonus(equipped,statID,statVal)
	if equipped==nil or statID==nil or statVal==nil or _TABLES.STATS[statID] == nil then return end;

	local cItemContainer = Turbine.UI.Control();
	cItemContainer:SetSize(set_lstBonus:GetWidth(),18);

	cItemContainer["PiecesNeeded"] = equipped;
	cItemContainer["StatID"] = statID;
	cItemContainer["StatVal"] = statVal;

	local rgbTag = Utils.HexTBColor(Turbine.UI.Color.Lime);
	local lblStat = NewItemInfoLabel(cItemContainer:GetWidth(),cItemContainer:GetHeight());
	lblStat:SetMarkupEnabled(true);
	lblStat:SetParent(cItemContainer);
	lblStat:SetMouseVisible(false);
	lblStat:SetText("["..equipped.."] <rgb=#"..rgbTag..">"..GetStatPrefix(statID)..Utils.comma_value(statVal)..GetStatSuffix(statID).." ".._TABLES.STATS[statID][LANGID].."</rgb>");

	cItemContainer.MouseClick = function (Sender,Args)
		if Args.Button == Turbine.UI.MouseButton.Right then
			local contextMenu = Turbine.UI.ContextMenu();
			local menuItems = contextMenu:GetItems();
			local cRemove = Turbine.UI.MenuItem(_LABELS[19][LANGID]);
			cRemove.Click = function()
				set_lstBonus:RemoveItem(cItemContainer);		-- For some reason this gets muddled up during sorting, thus the rewriting of the function after each sort *sigh*
			end
			menuItems:Add(cRemove);
			contextMenu:ShowMenu();
		end
	end

	set_lstBonus:AddItem(cItemContainer);
	set_SortBonuses();
end


function set_SortBonuses()

	local _sort = {};

	for i=1, set_lstBonus:GetItemCount() do
		local cItemContainer = set_lstBonus:GetItem(i);
		table.insert(_sort,{["PiecesNeeded"]=cItemContainer.PiecesNeeded;["Control"]=cItemContainer;});
	end

	table.sort(_sort,function(a,b) return a.PiecesNeeded<b.PiecesNeeded end);

	set_lstBonus:ClearItems();

	for k,v in ipairs(_sort) do
		set_lstBonus:AddItem(v.Control);
	end

end
