
function DrawBonusPopup()

	wBonusWin = Turbine.UI.Window();
	wBonusWin:SetSize(350,142);
	wBonusWin:SetPosition((SCREENWIDTH/2)-(wBonusWin:GetWidth()/2),(SCREENHEIGHT/2)-(wBonusWin:GetHeight()/2));
	wBonusWin:SetHideF12(true);
	wBonusWin:SetCloseEsc(true);
	wBonusWin:SetBackground(_IMAGES.BACKGROUNDS.SETS_BONUS);
	wBonusWin:SetBlendMode(4);
	bonus_lblNeeded = NewWindowLabel(wBonusWin,120,20,15,10,_LABELS[81][LANGID]..":");
	bonus_lblNeeded:SetMouseVisible(false);

	local _list = {};
	for i=2, 6 do
		table.insert(_list,i.." ".._LABELS[13][LANGID]);
	end

	bonus_ddNeeded = Utils.DropDown(_list);
	bonus_ddNeeded:SetParent(wBonusWin);
	bonus_ddNeeded:SetPosition(15,30);
	bonus_ddNeeded:SetSearchID(2);

	bonus_ddNeeded.ItemChanged = function (Sender,Args)
		bonus_ddNeeded:SetSearchID(Args.Index+1);
	end

	bonus_lblValue = NewWindowLabel(wBonusWin,60,20,15,bonus_ddNeeded:GetTop()+30,_LABELS[52][LANGID]);
	bonus_lblValue:SetMouseVisible(false);

	bonus_txtValue = NewWindowTextBox(wBonusWin,60,20,15,bonus_lblValue:GetTop()+20);
	RegisterEditEvent(bonus_txtValue);

	bonus_lblStat = NewWindowLabel(wBonusWin,100,20,bonus_txtValue:GetLeft()+bonus_txtValue:GetWidth()+10,bonus_lblValue:GetTop(),_LABELS[53][LANGID]);
	bonus_lblStat:SetMouseVisible(false);

	local _ddSort = {}
	for k,v in ipairs (_TABLES.STATS) do
		table.insert(_ddSort,v[LANGID]);
	end

	bonus_ddName = Utils.DropDown(_ddSort);
	bonus_ddName:SetParent(wBonusWin);
	bonus_ddName:SetPosition(bonus_txtValue:GetLeft()+bonus_txtValue:GetWidth()+10,bonus_txtValue:GetTop());
	bonus_ddName:SetWidth(250);
	bonus_ddName:SetAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	bonus_ddName:SetSearchID(GetDropDownSearchID(bonus_ddName,_TABLES.STATS));

	bonus_ddName.ItemChanged = function()
		bonus_ddName:SetSearchID(GetDropDownSearchID(bonus_ddName,_TABLES.STATS));
	end

	bonus_btnCancel = Turbine.UI.Lotro.Button();
	bonus_btnCancel:SetParent(wBonusWin);
	bonus_btnCancel:SetWidth(80);
	bonus_btnCancel:SetPosition(bonus_ddName:GetLeft()+bonus_ddName:GetWidth()-bonus_btnCancel:GetWidth(),bonus_ddName:GetTop()+30);
	bonus_btnCancel:SetText(_LABELS[55][LANGID]);

	bonus_btnCancel.Click = function()
		CloseBonusPopup();
	end

	bonus_btnClear = Turbine.UI.Lotro.Button();
	bonus_btnClear:SetParent(wBonusWin);
	bonus_btnClear:SetWidth(80);
	bonus_btnClear:SetPosition(bonus_btnCancel:GetLeft()-10-bonus_btnClear:GetWidth(),bonus_btnCancel:GetTop());
	bonus_btnClear:SetText(_LABELS[4][LANGID]);

	bonus_btnClear.Click = function()
		ResetBonusPopup();
	end

	bonus_btnSave = Turbine.UI.Lotro.Button();
	bonus_btnSave:SetParent(wBonusWin);
	bonus_btnSave:SetWidth(80);
	bonus_btnSave:SetPosition(bonus_btnCancel:GetLeft()-10-bonus_btnSave:GetWidth(),bonus_btnCancel:GetTop());
	bonus_btnSave:SetText(_LABELS[59][LANGID]);
	bonus_btnSave:SetVisible(false);

	bonus_btnSave.Click = function()
		SaveBonusEdit();
	end

	bonus_btnAdd = Turbine.UI.Lotro.Button();
	bonus_btnAdd:SetParent(wBonusWin);
	bonus_btnAdd:SetWidth(80);
	bonus_btnAdd:SetPosition(bonus_btnClear:GetLeft()-10-bonus_btnAdd:GetWidth(),bonus_btnCancel:GetTop());
	bonus_btnAdd:SetText(_LABELS[54][LANGID]);

	bonus_btnAdd.Click = function()
		AddNewBonus();
	end

	-- Window Events --
	wBonusWin.Closed = function ()
		ResetBonusPopup();
	end

	Utils.RegisterMouseMoveEvent(wBonusWin);
end


function DisplayBonusPopup()
	if wBonusWin == nil then DrawBonusPopup() end;
	wBonusWin:SetVisible(true);
	wBonusWin:Activate();
	bonus_txtValue:Focus();

	bonus_ddName:SetEnabled(true);

	bonus_btnAdd:SetVisible(true);
	bonus_btnClear:SetVisible(true);
	bonus_btnSave:SetVisible(false);
end


function DisplayBonusEdit(equipped,statID,statVal)
	if wBonusWin == nil then DrawBonusPopup() end;
	wBonusWin:SetVisible(true);
	wBonusWin:Activate();

	bonus_ddNeeded:SetText(equipped.." ".._LABELS[13][LANGID]);
	bonus_ddNeeded:SetSearchID(equipped);

	bonus_txtValue:SetText(statVal);
	bonus_txtValue:Focus();

	bonus_ddName:SetText(_TABLES.STATS[statID][LANGID]);
	bonus_ddName:SetSearchID(statID);
	bonus_ddName:SetEnabled(false);

	bonus_btnAdd:SetVisible(false);
	bonus_btnClear:SetVisible(false);
	bonus_btnSave:SetVisible(true);
end


function ResetBonusPopup()
	bonus_txtValue:SetText("");
	bonus_ddName:SetText(_TABLES.STATS[1][LANGID]);
	bonus_ddName:Reset();
	bonus_ddName:SetSearchID(1);
	bonus_ddNeeded:SetText("2 ".._LABELS[13][LANGID]);
	bonus_ddNeeded:Reset();
	bonus_ddNeeded:SetSearchID(2);
end


function AddNewBonus()
	if bonus_txtValue:GetText() ~= "" and tonumber(bonus_txtValue:GetText()) ~= 0 then
		set_AddBonus(bonus_ddNeeded:GetSearchID(),bonus_ddName:GetSearchID(),bonus_txtValue:GetText())
		CloseBonusPopup();
	else
		Utils.MessageBox(_LABELS[56][LANGID]);
	end
end


function SaveBonusEdit()
	print("To do: SaveBonusEdit()");
end


function CloseBonusPopup()
	if wBonusWin:IsVisible() == true then wBonusWin:Close() end;
end
