
function DrawBuildCopyPopup()
	wBuildCopy = Turbine.UI.Window();
	wBuildCopy:SetSize(350,250);
	wBuildCopy:SetBackground(_IMAGES.BACKGROUNDS.BUILDS_COPY);
	wBuildCopy:SetBlendMode(4);
	wBuildCopy:SetPosition((SCREENWIDTH/2)-(wBuildCopy:GetWidth()/2),(SCREENHEIGHT/2)-(wBuildCopy:GetHeight()/2));
	wBuildCopy:SetHideF12(true);
	wBuildCopy:SetCloseEsc(true);
	wBuildCopy["BuildID"] = 0;

	copy_lblCopy = NewWindowLabel(wBuildCopy,wBuildCopy:GetWidth()-40,18,20,10,_LABELS[100][LANGID]..":");
	copy_lblCopy:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	copy_lblCopy:SetMouseVisible(false);

	copy_lblName = NewWindowLabel(wBuildCopy,wBuildCopy:GetWidth()-40,18,20,copy_lblCopy:GetTop()+copy_lblCopy:GetHeight()+3);
	copy_lblName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	copy_lblName:SetForeColor(_COLORS[7]);
	copy_lblName:SetMouseVisible(false);

	copy_lblTo = NewWindowLabel(wBuildCopy,wBuildCopy:GetWidth()-40,18,20,copy_lblName:GetTop()+copy_lblName:GetHeight()+3,_LABELS[102][LANGID]..":");
	copy_lblTo:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	copy_lblTo:SetMouseVisible(false);

	copy_lstDestination = Turbine.UI.ListBox();
	copy_lstDestination:SetParent(wBuildCopy);
	copy_lstDestination:SetSize(250,90);
	copy_lstDestination:SetPosition((wBuildCopy:GetWidth()/2)-(copy_lstDestination:GetWidth()/2),copy_lblTo:GetTop()+25);
	copy_lstDestination["BuildID"] = 0;
	copy_sbDest = NewScrollBar(copy_lstDestination,"vertical",wBuildCopy);

	copy_lstDestination.SelectedIndexChanged = function ()
		for i=1, copy_lstDestination:GetItemCount() do
			if i == copy_lstDestination:GetSelectedIndex() then
				copy_lstDestination:GetItem(i):SetBackColor(_COLORS[12]);
			else
				copy_lstDestination:GetItem(i):SetBackColor();
			end
		end
	end

	copy_lblNote = NewWindowLabel(wBuildCopy,wBuildCopy:GetWidth()-40,36,20,copy_lstDestination:GetTop()+copy_lstDestination:GetHeight()+5,_LABELS[101][LANGID]);
	copy_lblNote:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	copy_lblNote:SetMouseVisible(false);

	copy_btnCancel = Turbine.UI.Lotro.Button();
	copy_btnCancel:SetParent(wBuildCopy);
	copy_btnCancel:SetWidth(80);
	copy_btnCancel:SetPosition(wBuildCopy:GetWidth()-10-copy_btnCancel:GetWidth(),wBuildCopy:GetHeight()-12-copy_btnCancel:GetHeight());
	copy_btnCancel:SetText(_LABELS[55][LANGID]);

	copy_btnCancel.Click = function()
		CloseCopyPopup();
	end

	copy_btnCopy = Turbine.UI.Lotro.Button();
	copy_btnCopy:SetParent(wBuildCopy);
	copy_btnCopy:SetWidth(80);
	copy_btnCopy:SetPosition(copy_btnCancel:GetLeft()-10-copy_btnCopy:GetWidth(),copy_btnCancel:GetTop());
	copy_btnCopy:SetText(_LABELS[95][LANGID]);

	copy_btnCopy.Click = function ()
		HandleCopyRequest(wBuildCopy.BuildID,copy_lstDestination.BuildID);
		CloseCopyPopup();
	end

	-- Window Events --
	Utils.RegisterMouseMoveEvent(wBuildCopy);
end


function DisplayBuildCopyPopup(buildID)
	if buildID == nil then return end;
	if wBuildCopy == nil then DrawBuildCopyPopup() end;

	wBuildCopy.BuildID = buildID;
	copy_lblName:SetText(_BUILDS[buildID][19]);
	UpdateCopyList(buildID);

	wBuildCopy:SetVisible(true);
	wBuildCopy:Activate();
end


function UpdateCopyList(buildID)
	copy_lstDestination:ClearItems();
	if buildID == nil then return end;

	for k, v in ipairs(_BUILDS) do
		if k~=buildID and k~=1 and v[19]~=nil then
			local cItemContainer = NewItemContainer(copy_lstDestination:GetWidth(),18);
			cItemContainer["BuildID"] = k;
			cItemContainer.MouseClick = function()
				copy_lstDestination.BuildID = k;
			end
			local lblName = NewWindowLabel(cItemContainer,cItemContainer:GetWidth()-4,18,2,0,v[19]);
			lblName:SetForeColor(_COLORS[3]);
			lblName:SetMouseVisible(false);
			lblName:SetMultiline(false);
			copy_lstDestination:AddItem(cItemContainer);
		end
	end

	local cItemContainer = NewItemContainer(copy_lstDestination:GetWidth(),18);
	cItemContainer["BuildID"] = #_BUILDS+1;
	cItemContainer.MouseClick = function()
		copy_lstDestination.BuildID = #_BUILDS+1;
	end

	local lblName = NewWindowLabel(cItemContainer,cItemContainer:GetWidth()-4,18,2,0,"..".._LABELS[84][LANGID]);
	lblName:SetForeColor(_COLORS[2]);
	lblName:SetMouseVisible(false);
	lblName:SetMultiline(false);
	copy_lstDestination:AddItem(cItemContainer);

	copy_lstDestination:SetSelectedIndex(1);
	copy_lstDestination.BuildID = copy_lstDestination:GetItem(1).BuildID;
end


function CloseCopyPopup()
	if wBuildCopy:IsVisible() then wBuildCopy:Close() end;
end
