
function DrawEquipmentWin()

	wEquipment = Turbine.UI.Lotro.Window();
	wEquipment:SetSize(600,500);
	wEquipment:SetPosition((SCREENWIDTH/2)-(wEquipment:GetWidth()/2),(SCREENHEIGHT/2)-(wEquipment:GetHeight()/2));
	wEquipment:SetText(_LABELS[103][LANGID]);
	wEquipment:SetHideF12(true);
	wEquipment:SetCloseEsc(true);

	back_equipment = Turbine.UI.Control();
	back_equipment:SetParent(wEquipment);
	back_equipment:SetSize(600,500);
	back_equipment:SetPosition(0,-3);
	back_equipment:SetBackground(_IMAGES.BACKGROUNDS.EQUIPMENT);
	back_equipment:SetBlendMode(4);
	back_equipment:SetMouseVisible(false);

	equip_lblInstructions = NewWindowLabel(wEquipment,wEquipment:GetWidth()-60,80,30,45,_LABELS[104][LANGID]);

	equip_lstItems = Turbine.UI.ListBox();
	equip_lstItems:SetParent(wEquipment);
	equip_lstItems:SetSize(wEquipment:GetWidth()-110,300);
	equip_lstItems:SetPosition(50,equip_lblInstructions:GetTop()+equip_lblInstructions:GetHeight()+10);
	equip_sbItems = NewScrollBar(equip_lstItems,"vertical",wEquipment);

	equip_btnCancel = Turbine.UI.Lotro.Button();
	equip_btnCancel:SetParent(wEquipment);
	equip_btnCancel:SetWidth(90);
	equip_btnCancel:SetPosition(equip_lstItems:GetLeft()+equip_lstItems:GetWidth()-equip_btnCancel:GetWidth(),equip_lstItems:GetTop()+equip_lstItems:GetHeight()+20);
	equip_btnCancel:SetText(_LABELS[55][LANGID]);

	equip_btnCancel.Click = function ()
		wEquipment:Close();
	end

	equip_btnSave = Turbine.UI.Lotro.Button();
	equip_btnSave:SetParent(wEquipment);
	equip_btnSave:SetWidth(90);
	equip_btnSave:SetPosition(equip_btnCancel:GetLeft()-10-equip_btnSave:GetWidth(),equip_btnCancel:GetTop());
	equip_btnSave:SetText(_LABELS[59][LANGID]);

	equip_btnSave.Click = function ()
		SaveEquipment();
	end

end


function SaveEquipment()
	for i=1, 18 do
		local listItem = equip_lstItems:GetItem(i);
		if listItem ~= nil and listItem.ItemID ~= 0 and _ITEMSDB[listItem.ItemID] ~= nil then
			AddToBuild(1,listItem.ItemID,i);
		end
	end
	wEquipment:Close();
end


function ShowEquipmentWin()
	if wEquipment == nil then DrawEquipmentWin() end;
	GetEquipment();
	equip_lstItems:EnsureVisible(1);
	wEquipment:SetVisible(true);
	wEquipment:Activate();
end


function GetEquipment()
	ResetEquipList();
	local equipment = PLAYERCHAR:GetEquipment();
	for i=1,18 do
		local item = equipment:GetItem(i)
		if item ~= nil then
			local listItem = equip_lstItems:GetItem(i);
			listItem:SetText(item:GetName());
			if _BUILDS[1][i] ~= nil and GetItemDatabaseName(_BUILDS[1][i]) == item:GetName() then
				local itemInstance = Utils.GetItemFromID(_BUILDS[1][i]);
				if itemInstance ~= nil then
					listItem["ItemID"] = _BUILDS[1][i];
					listItem:SetItem(itemInstance);
				end
			end
		end
	end
end


function ResetEquipList()
	equip_lstItems:ClearItems();
	for i=1, 18 do
		local cItemContainer = NewItemContainer(equip_lstItems:GetWidth(),48);
		cItemContainer["ItemID"] = 0;
		cItemContainer["ItemName"] = "";

		local buildSlot = Turbine.UI.Control();
		buildSlot:SetParent(cItemContainer);
		buildSlot:SetSize(44,44);
		buildSlot:SetPosition(2,2);
		buildSlot:SetVisible(true);
		buildSlot:SetBlendMode(4);
		buildSlot:SetToolTip(_TABLES.BUILDSLOTS[i][LANGID]);
		buildSlot:SetBackground(_IMAGES.SLOTS[i]);

		local cslotInfo = Turbine.UI.Lotro.ItemInfoControl();
		cslotInfo:SetParent(buildSlot);
		cslotInfo:SetSize(36,36);
		cslotInfo:SetPosition(3,3);
		cslotInfo:SetVisible(false);
		cslotInfo:SetQuantity(1);

		local lblName = NewWindowLabel(cItemContainer,cItemContainer:GetWidth()-100,44,50,2);
		lblName:SetForeColor(_COLORS[2]);

		local btnAdd = Turbine.UI.Lotro.Button();
		btnAdd:SetParent(cItemContainer);
		btnAdd:SetWidth(50);
		btnAdd:SetPosition(cItemContainer:GetWidth()-btnAdd:GetWidth()-5,(cItemContainer:GetHeight()/2)-(btnAdd:GetHeight()/2));
		btnAdd:SetText("+");
		btnAdd:SetToolTip(_LABELS[105][LANGID]);
		btnAdd:SetVisible(false);

		btnAdd.Click = function ()
			if wEditItemWin == nil then DrawEditItemWin() end;
			item_txtName:SetText(cItemContainer["ItemName"]);
			item_txtID:SetText(cItemContainer["ItemID"]);
			VerifyItemID(cItemContainer["ItemID"]);
			LoadItemData(cItemContainer["ItemID"]);
			item_cBlockThree:SetVisible(true);
			wEditItemWin:SetVisible(true);
			wEditItemWin:Activate();
		end

		cItemContainer.SetText = function (Sender,Text)
			lblName:SetText(Text);
			cItemContainer["ItemName"] = Text;
		end

		cItemContainer.ItemAdded = function ()
			lblName:SetForeColor(_COLORS[11]);
			btnAdd:SetVisible(false);
		end

		cItemContainer.SetItem = function (Sender,Item)
			if Item == nil then return end;
			cslotInfo:SetItemInfo(Item:GetItemInfo());
			cslotInfo:SetVisible(true);
			if _ITEMSDB[cItemContainer.ItemID] == nil then
				lblName:SetForeColor(_COLORS[10]);
				btnAdd:SetVisible(true);
			else
				lblName:SetForeColor(_COLORS[11]);
			end
		end

		equip_lstItems:AddItem(cItemContainer);
	end
end


function NewEquippedItemScan(ItemName,ItemID)
	if ItemName == nil or ItemID == nil then return end;
	-- loop through list of equipped items to match the name.
	for i=1, equip_lstItems:GetItemCount() do
		local item = equip_lstItems:GetItem(i);

		if item["ItemName"] == ItemName then
			local itemInstance = Utils.GetItemFromID(ItemID);
			if itemInstance ~= nil then
				item["ItemID"] = ItemID;
				item:SetItem(itemInstance);
			end
		end
	end
end


function ItemAddedEquippedUpdate(ItemID)
	if ItemID == nil then return end;
	if wEquipment ~= nil and wEquipment:IsVisible() then
		for i=1, equip_lstItems:GetItemCount() do
			local listItem = equip_lstItems:GetItem(i);
			if listItem["ItemID"] ~= nil and listItem["ItemID"] == ItemID then listItem:ItemAdded() end;
		end
	end
end
