
function GetScanItem(itemID)

	if itemID == nil then return end;
	local itemHex = Utils.TO_HEX(itemID);

	local cItemContainer = Turbine.UI.Control();
	cItemContainer:SetSize(160,70);
	cItemContainer["Selected"] = false;
	cItemContainer["Selectable"] = false;
	cItemContainer["ItemID"] = itemID;
	cItemContainer["ItemName"] = "";

	if _SELECTEDSCANS[itemID] ~= nil then cItemContainer.Selected = true end;

	local cBack = Turbine.UI.Control();
	cBack:SetParent(cItemContainer);
	cBack:SetWidth(cItemContainer:GetWidth()-4);
	cBack:SetHeight(cItemContainer:GetHeight()-4);
	cBack:SetPosition(2,2);
	cBack:SetMouseVisible(false);
	cItemContainer["Back"] = cBack;

	if cItemContainer.Selected == true then
		cBack:SetBackColor(_COLORS[14]);
	else
		cBack:SetBackColor(Turbine.UI.Color(0.06,0.06,0.06));
	end

	local lblID = Turbine.UI.Label();
	lblID:SetParent(cItemContainer);
	lblID:SetSize(cBack:GetWidth()-4,18);
	lblID:SetPosition(4,4);
	lblID:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblID:SetFont(_FONTS[4]);
	lblID:SetForeColor(_COLORS[4]);
	lblID:SetMouseVisible(false);
	lblID:SetText(itemID);

	local cItemInfo = NewItemInfo(itemID);
	cItemInfo:SetParent(cItemContainer);
	cItemInfo:SetPosition(4,20);

	local lblName = Turbine.UI.Label();
	lblName:SetParent(cItemContainer);
	lblName:SetPosition(43,cItemInfo:GetTop());
	lblName:SetSize(cBack:GetWidth()-2-lblName:GetLeft(),cItemInfo:GetHeight());
	lblName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	lblName:SetFont(_FONTS[4]);
	lblName:SetForeColor(_COLORS[4]);
	lblName:SetMouseVisible(false);
	lblName:SetText("");

	local itemInfo = cItemInfo:GetItemInfo();

	if itemInfo ~= nil then
		lblName:SetText(itemInfo:GetName());
		cItemContainer.ItemName = lblName:GetText();
		local itemQuality = itemInfo:GetQuality();
		if itemQuality < 1 or itemQuality > 5 then itemQuality = 5 end;
		lblName:SetForeColor(_QUALITYCOLORS[_GAMEVALUES.QUALITY[itemQuality]]);

		local cKnown = Turbine.UI.Control();
		cKnown:SetParent(cItemContainer);
		cKnown:SetSize(6,6);
		cKnown:SetPosition(cItemContainer:GetWidth()-6-cKnown:GetWidth(),6);

		cItemContainer.Selectable = true;

		if _ITEMSDB[itemID] ~= nil then
			cKnown:SetBackColor(Turbine.UI.Color.Lime);
		else
			cKnown:SetBackColor(Turbine.UI.Color.Red);
		end

		cItemContainer.MouseClick = function ()
			cItemContainer.Selected = not cItemContainer.Selected;
			if cItemContainer.Selected == true then
				cBack:SetBackColor(_COLORS[14]);
				_SELECTEDSCANS[itemID] = itemInfo:GetName();
			else
				cBack:SetBackColor(Turbine.UI.Color(0.06,0.06,0.06));
				_SELECTEDSCANS[itemID] = nil;
			end
		end
	end

	return cItemContainer;

end
