
function DrawStatPopup()

	wStatPopup = Turbine.UI.Window();
	wStatPopup:SetSize(350,95);
	wStatPopup:SetPosition((SCREENWIDTH/2)-(wStatPopup:GetWidth()/2),(SCREENHEIGHT/2)-(wStatPopup:GetHeight()/2));
	wStatPopup:SetBackground(_IMAGES.BACKGROUNDS.EDIT_STATS);
	wStatPopup:SetBlendMode(4);
	wStatPopup:SetHideF12(true);
	wStatPopup:SetCloseEsc(true);

	stat_lblValue = NewWindowLabel(wStatPopup,60,20,15,10,_LABELS[52][LANGID]);
	stat_lblValue:SetMouseVisible(false);

	stat_txtValue = NewWindowTextBox(wStatPopup,60,20,15,32);
	RegisterEditEvent(stat_txtValue);

	stat_lblStat = NewWindowLabel(wStatPopup,100,20,stat_txtValue:GetLeft()+stat_txtValue:GetWidth()+10,stat_lblValue:GetTop(),_LABELS[53][LANGID]);
	stat_lblStat:SetMouseVisible(false);

	local _ddSort = {}
	for k,v in ipairs (_TABLES.STATS) do
		table.insert(_ddSort,v[LANGID]);
	end

	stat_ddName = Utils.DropDown(_ddSort);
	stat_ddName:SetParent(wStatPopup);
	stat_ddName:SetPosition(stat_txtValue:GetLeft()+stat_txtValue:GetWidth()+10,stat_txtValue:GetTop());
	stat_ddName:SetWidth(250);
	stat_ddName:SetAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	stat_ddName:SetSearchID(GetDropDownSearchID(stat_ddName,_TABLES.STATS));

	stat_ddName.ItemChanged = function()
		stat_ddName:SetSearchID(GetDropDownSearchID(stat_ddName,_TABLES.STATS));
	end

	stat_btnCancel = Turbine.UI.Lotro.Button();
	stat_btnCancel:SetParent(wStatPopup);
	stat_btnCancel:SetWidth(80);
	stat_btnCancel:SetPosition(stat_ddName:GetLeft()+stat_ddName:GetWidth()-stat_btnCancel:GetWidth(),stat_ddName:GetTop()+30);
	stat_btnCancel:SetText(_LABELS[55][LANGID]);

	stat_btnCancel.Click = function()
		CloseStatPopup();
	end

	stat_btnClear = Turbine.UI.Lotro.Button();
	stat_btnClear:SetParent(wStatPopup);
	stat_btnClear:SetWidth(80);
	stat_btnClear:SetPosition(stat_btnCancel:GetLeft()-10-stat_btnClear:GetWidth(),stat_btnCancel:GetTop());
	stat_btnClear:SetText(_LABELS[4][LANGID]);

	stat_btnClear.Click = function()
		ResetStatPopup();
	end

	stat_btnSave = Turbine.UI.Lotro.Button();
	stat_btnSave:SetParent(wStatPopup);
	stat_btnSave:SetWidth(80);
	stat_btnSave:SetPosition(stat_btnCancel:GetLeft()-10-stat_btnSave:GetWidth(),stat_btnCancel:GetTop());
	stat_btnSave:SetText(_LABELS[59][LANGID]);
	stat_btnSave:SetVisible(false);

	stat_btnSave.Click = function()
		SaveStatEdit();
	end

	stat_btnAdd = Turbine.UI.Lotro.Button();
	stat_btnAdd:SetParent(wStatPopup);
	stat_btnAdd:SetWidth(80);
	stat_btnAdd:SetPosition(stat_btnClear:GetLeft()-10-stat_btnAdd:GetWidth(),stat_btnCancel:GetTop());
	stat_btnAdd:SetText(_LABELS[54][LANGID]);

	stat_btnAdd.Click = function()
		AddNewStat();
	end


	-- Window Events --
	wStatPopup.Closed = function ()
		ResetStatPopup();
	end

	Utils.RegisterMouseMoveEvent(wStatPopup);

end


function DisplayStatPopup()
	if wStatPopup == nil then DrawStatPopup() end;
	wStatPopup:SetVisible(true);
	wStatPopup:Activate();
	stat_txtValue:Focus();

	stat_ddName:SetEnabled(true);

	stat_btnAdd:SetVisible(true);
	stat_btnClear:SetVisible(true);
	stat_btnSave:SetVisible(false);
end


function DisplayStatEdit(statID,statVal)
	if wStatPopup == nil then DrawStatPopup() end;
	wStatPopup:SetVisible(true);
	wStatPopup:Activate();
	stat_txtValue:SetText(statVal);
	stat_txtValue:Focus();

	stat_ddName:SetText(_TABLES.STATS[statID][LANGID]);
	stat_ddName:SetSearchID(statID);
	stat_ddName:SetEnabled(false);

	stat_btnAdd:SetVisible(false);
	stat_btnClear:SetVisible(false);
	stat_btnSave:SetVisible(true);
end


function ResetStatPopup()
	stat_txtValue:SetText("");
	stat_ddName:SetText(_TABLES.STATS[1][LANGID]);
	stat_ddName:Reset();
	stat_ddName:SetSearchID(1);
end


function CloseStatPopup()
	if wStatPopup:IsVisible() == true then wStatPopup:Close() end;
end


function AddNewStat()
	if stat_txtValue:GetText() ~= "" and tonumber(stat_txtValue:GetText()) ~= 0 then
		HandleNewStat(stat_ddName:GetSearchID(),stat_txtValue:GetText());
		CloseStatPopup();
	else
		Utils.MessageBox(_LABELS[56][LANGID]);
	end
end


function SaveStatEdit()
	if stat_txtValue:GetText() ~= "" and tonumber(stat_txtValue:GetText()) ~= 0 then
		HandleEditStat(stat_ddName:GetSearchID(),stat_txtValue:GetText());
		CloseStatPopup();
	else
		Utils.MessageBox(_LABELS[56][LANGID]);
	end
end

