
function DrawMainWin()

	local tempWidth = 250;
	local tempHeight = 200;

	-- Main Parent window to hold all the elements
	wMainWinParent = Turbine.UI.Lotro.Window();
	wMainWinParent:SetSize(tempWidth,tempHeight);
	wMainWinParent:SetPosition(SETTINGS.MAINWIN.X,SETTINGS.MAINWIN.Y);
	wMainWinParent:SetText("Tulkas");
	wMainWinParent:SetHideF12(true);
	wMainWinParent:SetCloseEsc(true);

	if wMainWinParent:IsVisible() == true then wMainWinParent:Activate() end;

	Utils.Onscreen(wMainWinParent); -- Makes sure the window is still onscreen (perhaps user changed resolution since last playing)

	-- Background control to hold the background image
	wMainWinBack = Turbine.UI.Control();
	wMainWinBack:SetParent(wMainWinParent);
	wMainWinBack:SetSize(tempWidth,tempHeight);
	wMainWinBack:SetBlendMode(4);
	--wMainWinBack:SetBackground(_IMAGES.MAINWINBACK);
	wMainWinBack:SetMouseVisible(false);

	lblWelcome = Turbine.UI.Label();
	lblWelcome:SetParent(wMainWinParent);
	lblWelcome:SetSize(tempWidth-40,40);
	lblWelcome:SetPosition(20,50);
	lblWelcome:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	lblWelcome:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	lblWelcome:SetText(_STRINGS.MAIN.WELCOME[LANGID]);

	Utils.ClearTable(_STRINGS.MAIN.WELCOME);

	lstMainOptions = Turbine.UI.ListBox();
	lstMainOptions:SetParent(wMainWinParent);
	lstMainOptions:SetSize(tempWidth-40,0);
	lstMainOptions:SetPosition(20,lblWelcome:GetTop()+lblWelcome:GetHeight()+10);

	BuildOptionsList();

	-- Window Events --
	wMainWinParent.PositionChanged = function()
		SETTINGS.MAINWIN.X = wMainWinParent:GetLeft();
		SETTINGS.MAINWIN.Y = wMainWinParent:GetTop();
	end
end


function BuildOptionsList()

	lstMainOptions:ClearItems();

	local BARHEIGHT = 36;

	local sortTable = {};
	for k,v in pairs (_STRINGS.MAIN.OPTIONS) do
		table.insert(sortTable,k);
	end
	table.sort(sortTable);

	for k,v in pairs (sortTable) do
		v = _STRINGS.MAIN.OPTIONS[k];

		local cItemContainer = Utils.Button();
		cItemContainer:SetSize(210,BARHEIGHT);
		cItemContainer:SetImageNormal(_IMAGES.BUTTONS.MENU.NORMAL);		-- Standard button image
		cItemContainer:SetImageOver(_IMAGES.BUTTONS.MENU.OVER);		-- Image used when mouse is over the control

		local cIcon = Turbine.UI.Control();
		cIcon:SetParent(cItemContainer);
		cIcon:SetSize(28,28);
		cIcon:SetPosition(2,4);
		cIcon:SetBlendMode(4);
		cIcon:SetBackground(v.ICON);
		cIcon:SetMouseVisible(false);

		local cLabel = Turbine.UI.Label();
		cLabel:SetParent(cItemContainer);
		cLabel:SetSize(cItemContainer:GetWidth()-cIcon:GetWidth()-10,26);
		cLabel:SetPosition(cIcon:GetWidth()+10,5);
		cLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
		cLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
		cLabel:SetOutlineColor(Turbine.UI.Color.Black);
		cLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
		cLabel:SetText(v.LABEL[LANGID]);
		cLabel:SetMouseVisible(false);

		cItemContainer.Click = function ()
			-- Open relevant window
			HandleWindowLoad(v.POPUP);
			if k == 2 then PrepareResults(_BOOKMARKS) end;		-- Bookmarks button
		end

		lstMainOptions:AddItem(cItemContainer);
		lstMainOptions:SetHeight(lstMainOptions:GetHeight()+BARHEIGHT);

	end

	wMainWinParent:SetHeight(lstMainOptions:GetTop()+lstMainOptions:GetHeight()+30);
	Utils.ClearTable(_STRINGS.MAIN.OPTIONS.LABEL);
end


function HandleWindowLoad(WINDOW)

	-- Check if WINDOW has been drawn yet, if not draw it.
	if _G.GaluhadPlugins.Tulkas.Windows[WINDOW] == nil then

		-- Make sure it's properly referenced in the table, if not throw an error
		if _TABLES.WINDOWS[WINDOW] ~= nil then
			_G.GaluhadPlugins.Tulkas.Windows[_TABLES.WINDOWS[WINDOW]]();
		else
			printError("'" .. WINDOW .. "' in HandleWindowLoad()");
			return;
		end
	end

	-- Open and activate window
	local windowLink = _G.GaluhadPlugins.Tulkas.Windows[WINDOW];
	if windowLink:IsVisible() == true then
		--windowLink:Close();
	else
		windowLink:SetVisible(true);
		windowLink:Activate();
	end

	wMainWinParent:Close();
end


