
function DrawMissingItemsWin()

	local tempWidth = math.floor(SCREENWIDTH*0.8);
	local tempHeight = math.floor(SCREENHEIGHT*0.8);

	wMissingItemsWin = Turbine.UI.Lotro.Window();
	wMissingItemsWin:SetMinimumSize(MINWIDTH,MINHEIGHT);
	wMissingItemsWin:SetSize(tempWidth,tempHeight);
	tempWidth = wMissingItemsWin:GetWidth();
	tempHeight = wMissingItemsWin:GetHeight();
	wMissingItemsWin:SetPosition((SCREENWIDTH/2)-(tempWidth/2),(SCREENHEIGHT/2)-(tempHeight/2));
	wMissingItemsWin:SetText(_LABELS[68][LANGID]);
	wMissingItemsWin:SetVisible(false);
	wMissingItemsWin:SetHideF12(true);
	wMissingItemsWin:SetCloseEsc(false);

	Utils.Onscreen(wMissingItemsWin);

	-- Search Header
	scan_cSearchHolder = Turbine.UI.Control();
	scan_cSearchHolder:SetParent(wMissingItemsWin);
	scan_cSearchHolder:SetSize(813,30);
	scan_cSearchHolder:SetPosition((tempWidth/2)-(scan_cSearchHolder:GetWidth()/2),45);
	scan_cSearchHolder:SetBackground(_IMAGES.BACKGROUNDS.SCAN_HEADER);
	scan_cSearchHolder:SetBlendMode(4);

	scan_lblStart = NewWindowLabel(scan_cSearchHolder,80,20,10,5,_LABELS[69][LANGID]..":");
	scan_lblStart:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);

	scan_txtStart = NewWindowTextBox(scan_cSearchHolder,93,20,scan_lblStart:GetLeft()+scan_lblStart:GetWidth()+10,5,SETTINGS.SCAN.PREVID);
	scan_txtStart:SetToolTip(_LABELS[76][LANGID]..": "..FIRSTKNOWNID.." - "..LASTKNOWNID);

	scan_txtStart.TextChanged = function ()
		scan_txtStart:SetText(string.match(scan_txtStart:GetText(),"%f[%.%d]%d*%.?%d*%f[^%.%d%]]"));
		scan_txtStart:SetText(string.sub(scan_txtStart:GetText(),1,10));
	end

	scan_txtStart.KeyDown = function (Sender,Args)
		if Args.Action==162 then
			scan_btnGo:Focus();
			PrepareMissingScans();
		end
	end

	scan_txtStart.FocusGained = function()
		scan_txtStart:SetWantsKeyEvents(true);
	end

	scan_txtStart.FocusLost = function()
		scan_txtStart:SetWantsKeyEvents(false);
	end

	scan_lblMaxID = NewWindowLabel(scan_cSearchHolder,140,20,scan_txtStart:GetLeft()+scan_txtStart:GetWidth()+20,5,_LABELS[70][LANGID]..":");
	scan_lblMaxID:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);

	scan_txtMaxID = NewWindowTextBox(scan_cSearchHolder,80,20,scan_lblMaxID:GetLeft()+scan_lblMaxID:GetWidth()+10,5,SETTINGS.SCAN.MAX);
	RegisterEditEvent(scan_txtMaxID);

	scan_btnGo = Turbine.UI.Lotro.Button();
	scan_btnGo:SetParent(scan_cSearchHolder);
	scan_btnGo:SetWidth(80);
	scan_btnGo:SetPosition(scan_txtMaxID:GetLeft()+scan_txtMaxID:GetWidth()+20,5);
	scan_btnGo:SetText(_LABELS[71][LANGID]);

	scan_btnGo.Click = function ()
		PrepareMissingScans();
	end

	scan_btnSelectAll = Turbine.UI.Lotro.Button();
	scan_btnSelectAll:SetParent(scan_cSearchHolder);
	scan_btnSelectAll:SetWidth(100);
	scan_btnSelectAll:SetPosition(scan_btnGo:GetLeft()+scan_btnGo:GetWidth()+35,scan_btnGo:GetTop());
	scan_btnSelectAll:SetText(_LABELS[67][LANGID]);

	scan_btnSelectAll.Click = function ()
		Scan_SelectAll();
	end

	scan_btnAdd = Turbine.UI.Lotro.Button();
	scan_btnAdd:SetParent(scan_cSearchHolder);
	scan_btnAdd:SetWidth(100);
	scan_btnAdd:SetPosition(scan_btnSelectAll:GetLeft()+scan_btnSelectAll:GetWidth()+15,scan_btnSelectAll:GetTop());
	scan_btnAdd:SetText(_LABELS[72][LANGID]);

	scan_btnAdd.Click = function ()
		Scan_AddItems();
	end

	-- Results display
	scan_lblResults = NewWindowLabel(wMissingItemsWin,400,18,30,scan_cSearchHolder:GetTop()+scan_cSearchHolder:GetHeight()+15,"");
	scan_lblResults:SetForeColor(_COLORS[3]);

	scan_lstResults = Turbine.UI.ListBox();
	scan_lstResults:SetParent(wMissingItemsWin);
	scan_lstResults:SetPosition(30,scan_lblResults:GetTop()+scan_lblResults:GetHeight()+5);
	scan_lstResults:SetSize(tempWidth-(scan_lstResults:GetLeft()*2)-12,tempHeight-60-scan_lstResults:GetTop());
	scan_lstResults:SetOrientation(Turbine.UI.Orientation.Horizontal);

	scan_sbResults = NewScrollBar(scan_lstResults,"vertical",wMissingItemsWin);

	-- pagenate controls
	scan_backPageControls = Turbine.UI.Control();
	scan_backPageControls:SetParent(wMissingItemsWin);
	scan_backPageControls:SetSize(380,30);
	scan_backPageControls:SetPosition((wMissingItemsWin:GetWidth()/2)-(scan_backPageControls:GetWidth()/2),wMissingItemsWin:GetHeight()-scan_backPageControls:GetHeight()-20);
	scan_backPageControls:SetBackground(_IMAGES.BACKGROUNDS.PAGENATE);
	scan_backPageControls:SetBlendMode(4);

	scan_cPageHolder = Turbine.UI.Control();
	scan_cPageHolder:SetParent(scan_backPageControls);
	scan_cPageHolder:SetSize(350,20);
	scan_cPageHolder:SetPosition(15,5);

	scan_cNumHolder = NewItemContainer(140,20);
	scan_cNumHolder:SetParent(scan_cPageHolder);
	scan_cNumHolder:SetPosition((scan_cPageHolder:GetWidth()/2)-(scan_cNumHolder:GetWidth()/2),0);

	scan_txtPageNum = NewWindowTextBox(scan_cNumHolder,60,18,(scan_cNumHolder:GetWidth()/2)-62,2,"");
	scan_txtPageNum:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	scan_txtPageNum:SetFont(_FONTS[5]);
	RegisterEditEvent(scan_txtPageNum);

	scan_txtPageNum.KeyDown = function (Sender,Args)
		if Args.Action==162 then
			SCAN_PAGE = string.gsub(scan_txtPageNum:GetText(),"[%,]","");
			SCAN_PAGE = math.floor(tonumber(SCAN_PAGE));
			PagenateScanResults(SCAN_PAGE);
		end
	end

	scan_lblPageNum = Turbine.UI.Label();
	scan_lblPageNum:SetParent(scan_cNumHolder);
	scan_lblPageNum:SetSize(60,18);
	scan_lblPageNum:SetPosition((scan_cNumHolder:GetWidth()/2)+2,2);
	scan_lblPageNum:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	scan_lblPageNum:SetFont(_FONTS[5]);
	scan_lblPageNum:SetFontStyle(Turbine.UI.FontStyle.Outline);
	scan_lblPageNum:SetOutlineColor(_COLORS[5]);
	scan_lblPageNum:SetForeColor(_COLORS[3]);
	scan_lblPageNum:SetMultiline(false);
	scan_lblPageNum:SetText("");

	scan_btnLast = NewPagenateButton();
	scan_btnLast:SetParent(scan_cPageHolder);
	scan_btnLast:SetPosition(scan_cPageHolder:GetWidth()-scan_btnLast:GetWidth(),0);
	scan_btnLast:SetText(">>");
	scan_btnLast:SetToolTip(_TOOLTIPS[4][LANGID]);
	scan_btnLast:SetEnabled(false);

	scan_btnLast.Click = function ()
		SCAN_PAGE = -1;
		PagenateScanResults(SCAN_PAGE);
	end

	scan_btnNext = NewPagenateButton();
	scan_btnNext:SetParent(scan_cPageHolder);
	scan_btnNext:SetPosition(scan_btnLast:GetLeft()-scan_btnNext:GetWidth()-5,0);
	scan_btnNext:SetText(">");
	scan_btnNext:SetToolTip(_TOOLTIPS[3][LANGID]);
	scan_btnNext:SetEnabled(false);

	scan_btnNext.Click = function ()
		SCAN_PAGE = SCAN_PAGE + 1;
		PagenateScanResults(SCAN_PAGE);
	end

	scan_btnFirst = NewPagenateButton();
	scan_btnFirst:SetParent(scan_cPageHolder);
	scan_btnFirst:SetPosition(0,0);
	scan_btnFirst:SetText("<<");
	scan_btnFirst:SetToolTip(_TOOLTIPS[1][LANGID]);
	scan_btnFirst:SetEnabled(false);

	scan_btnFirst.Click = function ()
		SCAN_PAGE = 1;
		PagenateScanResults(SCAN_PAGE);
	end

	scan_btnPrev = NewPagenateButton();
	scan_btnPrev:SetParent(scan_cPageHolder);
	scan_btnPrev:SetPosition(scan_btnFirst:GetLeft()+scan_btnFirst:GetWidth()+5,0);
	scan_btnPrev:SetText("<");
	scan_btnPrev:SetToolTip(_TOOLTIPS[2][LANGID]);
	scan_btnPrev:SetEnabled(false);

	scan_btnPrev.Click = function ()
		SCAN_PAGE = SCAN_PAGE - 1;
		PagenateScanResults(SCAN_PAGE);
	end


	-- Window Events --

end


function PrepareMissingScans(idStart)
	if wMissingItemsWin == nil then DrawMissingItemsWin() end;
	if idStart == nil then
		_SCANINFO["StartID"] = math.floor(tonumber(scan_txtStart:GetText()));
	else
		_SCANINFO["StartID"] = idStart;
		scan_txtStart:SetText(idStart);
	end
	_SCANINFO["Get"] = math.floor(tonumber(scan_txtMaxID:GetText()));
	_SCANINFO["EndID"] = _SCANINFO.StartID + _SCANINFO.Get-1;
	SETTINGS.SCAN.PREVID = _SCANINFO.EndID+1;
	SETTINGS.SCAN.MAX = _SCANINFO.Get;
	scan_txtStart:SetText(_SCANINFO.EndID+1);
	SCAN_PAGE = 1;
	PagenateScanResults(SCAN_PAGE);
end


function PagenateScanResults(pageNum)
	if pageNum == nil then pageNum = 1 end;

	scan_lstResults:ClearItems();

	local itemWidth = 160;
	local itemHeight = 70;

	local maxRows = math.floor(scan_lstResults:GetHeight()/itemHeight);
	local maxCols = math.floor(scan_lstResults:GetWidth()/itemWidth);
	local maxPerPage = maxRows*maxCols;
	local pages = math.ceil(_SCANINFO.Get/maxPerPage);

	if pageNum == -1 or pageNum > pages then -- used as id for last page when button is pressed
		pageNum = pages;
		SCAN_PAGE = pageNum;
	end

	if pages == 0 then
		scan_txtPageNum:SetText("0");
		scan_lblPageNum:SetText("/0");
		scan_lblResults:SetText("");
	else
		scan_txtPageNum:SetText(Utils.comma_value(pageNum));
		scan_lblPageNum:SetText("/"..Utils.comma_value(pages));
		local first = ((pageNum-1)*maxPerPage)+1;
		local last = pageNum*maxPerPage;
		if last>_SCANINFO.Get then last = _SCANINFO.Get end;
		scan_lblResults:SetText(_LABELS[75][LANGID]..": "..Utils.comma_value(first).." - "..Utils.comma_value(last));
	end

	scan_lstResults:SetMaxItemsPerLine(maxCols);

	local firstOnPage = _SCANINFO.StartID + ((pageNum-1)*maxPerPage);
	local lastOnPage = firstOnPage+maxPerPage-1;

	for i=firstOnPage,lastOnPage do
		if i>_SCANINFO.EndID then break end;
		local cItemInfo = Includes.GetScanItem(i);
		scan_lstResults:AddItem(cItemInfo);
	end

	scan_lstResults:EnsureVisible(1);

	-- Handle button states
	-- First & Prev
	if pageNum == 1 then
		scan_btnPrev:SetEnabled(false);
		scan_btnFirst:SetEnabled(false);
	else
		scan_btnPrev:SetEnabled(true);
		scan_btnFirst:SetEnabled(true);
	end
	-- Next & Last
	if pageNum == pages or pages == 0 then
		scan_btnNext:SetEnabled(false);
		scan_btnLast:SetEnabled(false);
	else
		scan_btnNext:SetEnabled(true);
		scan_btnLast:SetEnabled(true);
	end

	scan_lstResults:SetWidth(itemWidth*maxCols);
	scan_lstResults:SetLeft((wMissingItemsWin:GetWidth()/2)-(scan_lstResults:GetWidth()/2));
	scan_lblResults:SetLeft(scan_lstResults:GetLeft());

end


function Scan_AddItems()
	if type(_SELECTEDSCANS) ~= 'table' then return end;
	local selected = false;
	for k,v in pairs (_SELECTEDSCANS) do
		selected = true;
		break;
	end

	if selected == false then
		Utils.MessageBox(_LABELS[63][LANGID]);
		return;
	end

	for k,v in pairs (_SELECTEDSCANS) do
		NewChannelScan(v,k)
	end

	wEditItemWin:SetVisible(true);
	wEditItemWin:Activate();

	for i=1,scan_lstResults:GetItemCount() do
		local item = scan_lstResults:GetItem(i);
		if item.Selected == true then
			item.Selected = false;
			item.Back:SetBackColor(Turbine.UI.Color(0.06,0.06,0.06));
		end
	end

	_SELECTEDSCANS = {};
end


function Scan_SelectAll()
	for i=1, scan_lstResults:GetItemCount() do
		local item = scan_lstResults:GetItem(i);
		if item.Selectable == true then
			item.Selected = true;
			item.Back:SetBackColor(_COLORS[14]);
			_SELECTEDSCANS[item.ItemID] = item.ItemName;
		end
	end
end
