
function DrawSearchWin()

	local tempWidth = math.floor(SCREENWIDTH*0.8);
	local tempHeight = math.floor(SCREENHEIGHT*0.8);

	--tempWidth = MINWIDTH;
	--tempHeight = MINHEIGHT;

	wSearchWin = Turbine.UI.Lotro.Window();
	wSearchWin:SetMinimumSize(MINWIDTH,MINHEIGHT);
	wSearchWin:SetSize(tempWidth,tempHeight);
	wSearchWin:SetPosition(SETTINGS.SEARCHWIN.X,SETTINGS.SEARCHWIN.Y);
	wSearchWin:SetText(_LABELS[1][LANGID]);
	wSearchWin:SetVisible(false);
	wSearchWin:SetHideF12(true);
	wSearchWin:SetCloseEsc(false);

	tempWidth = wSearchWin:GetWidth();
	tempHeight = wSearchWin:GetHeight();

	Utils.Onscreen(wSearchWin);

	-- MAIN SEARCH PANEL ---------------------------------------------------------------------------------------------
	search_cSearchPanel = Turbine.UI.Control();
	search_cSearchPanel:SetParent(wSearchWin);
	search_cSearchPanel:SetBackground(_IMAGES.BACKGROUNDS.SEARCH_BAR);

	search_cBookmarks = Utils.Button();
	search_cBookmarks:SetParent(search_cSearchPanel);
	search_cBookmarks:SetSize(20,20);
	search_cBookmarks:SetPosition(10,5);
	search_cBookmarks:SetImageNormal(_IMAGES.BUTTONS.BOOKMARK_SELECTED.NORMAL);
	search_cBookmarks:SetImageOver(_IMAGES.BUTTONS.BOOKMARK_SELECTED.OVER);
	search_cBookmarks:SetToolTip(_STRINGS.MAIN.OPTIONS[2]["LABEL"][LANGID]);

	search_cBookmarks.Click = function()
		PrepareResults(_BOOKMARKS);
	end

	search_txtName = Turbine.UI.TextBox();
	search_txtName:SetParent(search_cSearchPanel);
	search_txtName:SetPosition(search_cBookmarks:GetLeft()+search_cBookmarks:GetWidth()+20,5);
	search_txtName:SetSize(330,20);
	search_txtName:SetSelectable(true);
	search_txtName:SetMultiline(false);
	search_txtName:SetBackColor(_COLORS[3]);
	search_txtName:SetForeColor(_COLORS[2]);
	search_txtName:SetFont(_FONTS[1]);
	search_txtName:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_txtName:SetText(_LABELS[10][LANGID]);

	search_txtName.FocusGained = function ()
		if search_txtName:GetText() == _LABELS[10][LANGID] then
			search_txtName:SetText("");
		end
		search_txtName:SetForeColor(_COLORS[1]);
		search_txtMinLevel:SetWantsKeyEvents(true);
	end

	search_txtName.FocusLost = function()
		search_txtName:SetWantsKeyEvents(false);
	end

	search_txtName.KeyDown = function(Sender,Args)
		if Args.Action == 162 then PerformSearch() end; -- Performs search when enter is pressed.
	end

	search_btnSearch = Turbine.UI.Lotro.Button();
	search_btnSearch:SetParent(search_cSearchPanel);
	search_btnSearch:SetWidth(120);
	search_btnSearch:SetPosition(search_txtName:GetLeft()+search_txtName:GetWidth()+20,search_txtName:GetTop());
	search_btnSearch:SetText(_LABELS[2][LANGID]);

	search_btnSearch.Click = function()
		PerformSearch();
	end

	search_btnAdvanced = Turbine.UI.Lotro.Button();
	search_btnAdvanced:SetParent(search_cSearchPanel);
	search_btnAdvanced:SetWidth(120);
	search_btnAdvanced:SetPosition(search_btnSearch:GetLeft()+search_btnSearch:GetWidth()+20,search_btnSearch:GetTop());
	search_btnAdvanced:SetText(_LABELS[3][LANGID]);
	search_btnAdvanced:SetToolTip(_TOOLTIPS[5][LANGID]);

	search_btnAdvanced.Click = function()
		DisplayAdvancedSearch();
	end

	search_btnSimple = Turbine.UI.Lotro.Button();
	search_btnSimple:SetParent(search_cSearchPanel);
	search_btnSimple:SetWidth(search_btnAdvanced:GetWidth());
	search_btnSimple:SetPosition(search_btnAdvanced:GetPosition());
	search_btnSimple:SetText(_LABELS[5][LANGID]);
	search_btnSimple:SetVisible(false);
	search_btnSimple:SetToolTip(_TOOLTIPS[6][LANGID]);

	search_btnSimple.Click = function()
		HideAdvancedSearch();
	end

	search_btnHistory = Turbine.UI.Lotro.Button();
	search_btnHistory:SetParent(search_cSearchPanel);
	search_btnHistory:SetWidth(120);
	search_btnHistory:SetPosition(search_btnAdvanced:GetLeft()+search_btnAdvanced:GetWidth()+20,search_btnSearch:GetTop());
	search_btnHistory:SetText(_LABELS[16][LANGID]);
	search_btnHistory:SetToolTip(_TOOLTIPS[8][LANGID]);
	if table.getn(_SEARCHHISTORY) == 0 then search_btnHistory:SetEnabled(false) end;

	search_btnHistory.Click = function()
		DisplaySearchHistoryWin();
	end

	search_btnClear = Turbine.UI.Lotro.Button();
	search_btnClear:SetParent(search_cSearchPanel);
	search_btnClear:SetWidth(120);
	search_btnClear:SetPosition(search_btnHistory:GetLeft()+search_btnHistory:GetWidth()+60,search_btnSearch:GetTop());
	search_btnClear:SetText(_LABELS[4][LANGID]);
	search_btnClear:SetToolTip(_TOOLTIPS[7][LANGID]);
	search_btnClear:SetVisible(false);
	search_btnClear.Click = function()
		ResetSearch();
	end


	-- Position the bar in the center of the window
	search_cSearchPanel:SetSize(search_btnClear:GetLeft()+search_btnClear:GetWidth()+10,30); -- 990x30
	search_cSearchPanel:SetPosition((tempWidth/2)-(search_cSearchPanel:GetWidth()/2),40);


	---------------------------------------------------------------------------------------------------------------------------------

	-- Advanced Search Popout
	search_cSearchAdvanced = Turbine.UI.Control();
	search_cSearchAdvanced:SetParent(wSearchWin);
	search_cSearchAdvanced:SetSize(990,440);
	search_cSearchAdvanced:SetPosition((tempWidth/2)-(search_cSearchAdvanced:GetWidth()/2),search_cSearchPanel:GetTop()+search_cSearchPanel:GetHeight()-2);
	search_cSearchAdvanced:SetBackground(_IMAGES.BACKGROUNDS.SEARCH_ADVANCED);
	search_cSearchAdvanced:SetZOrder(100000);
	search_cSearchAdvanced:SetVisible(false);

	-- Block one --
	search_cSearchBlockOne = Turbine.UI.Control();
	search_cSearchBlockOne:SetParent(search_cSearchAdvanced);
	search_cSearchBlockOne:SetSize(160,search_cSearchAdvanced:GetHeight()-40);
	search_cSearchBlockOne:SetPosition(10,30);

	search_txtMinLevel = Turbine.UI.TextBox();
	search_txtMinLevel:SetParent(search_cSearchBlockOne);
	search_txtMinLevel:SetPosition(0,0);
	search_txtMinLevel:SetSize(30,20);
	search_txtMinLevel:SetSelectable(true);
	search_txtMinLevel:SetMultiline(false);
	search_txtMinLevel:SetBackColor(_COLORS[3]);
	search_txtMinLevel:SetForeColor(_COLORS[1]);
	search_txtMinLevel:SetFont(_FONTS[1]);
	search_txtMinLevel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	search_txtMinLevel:SetText("");

	search_txtMinLevel.TextChanged = function ()
		search_txtMinLevel:SetText(string.gsub(search_txtMinLevel:GetText(),"%D","")); -- Filters numbers only
	end

	search_txtMinLevel.FocusGained = function()
		search_txtMinLevel:SetWantsKeyEvents(true);
	end

	search_txtMinLevel.FocusLost = function()
		search_txtMinLevel:SetWantsKeyEvents(false);
	end

	search_txtMinLevel.KeyDown = function(Sender,Args)
		if Args.Action == 162 then search_txtMaxLevel:Focus() end; -- Jumps to next textbox when enter is pressed.
	end

	search_lblMinLevel = Turbine.UI.Label();
	search_lblMinLevel:SetParent(search_cSearchBlockOne);
	search_lblMinLevel:SetSize(120,search_txtMinLevel:GetHeight());
	search_lblMinLevel:SetPosition(search_txtMinLevel:GetLeft()+search_txtMinLevel:GetWidth()+10,search_txtMinLevel:GetTop());
	search_lblMinLevel:SetFont(_FONTS[1]);
	search_lblMinLevel:SetForeColor(_COLORS[4]);
	search_lblMinLevel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblMinLevel:SetText(_LABELS[6][LANGID]);

	search_txtMaxLevel = Turbine.UI.TextBox();
	search_txtMaxLevel:SetParent(search_cSearchBlockOne);
	search_txtMaxLevel:SetPosition(search_txtMinLevel:GetLeft(),search_txtMinLevel:GetTop()+search_txtMinLevel:GetHeight()+10);
	search_txtMaxLevel:SetSize(30,20);
	search_txtMaxLevel:SetSelectable(true);
	search_txtMaxLevel:SetMultiline(false);
	search_txtMaxLevel:SetBackColor(_COLORS[3]);
	search_txtMaxLevel:SetForeColor(_COLORS[1]);
	search_txtMaxLevel:SetFont(_FONTS[1]);
	search_txtMaxLevel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	search_txtMaxLevel:SetText("");

	search_txtMaxLevel.TextChanged = function ()
		search_txtMaxLevel:SetText(string.gsub(search_txtMaxLevel:GetText(),"%D","")); -- Filters numbers only
	end

	search_lblMaxLevel = Turbine.UI.Label();
	search_lblMaxLevel:SetParent(search_cSearchBlockOne);
	search_lblMaxLevel:SetSize(120,search_txtMaxLevel:GetHeight());
	search_lblMaxLevel:SetPosition(search_txtMaxLevel:GetLeft()+search_txtMaxLevel:GetWidth()+10,search_txtMaxLevel:GetTop());
	search_lblMaxLevel:SetFont(_FONTS[1]);
	search_lblMaxLevel:SetForeColor(_COLORS[4]);
	search_lblMaxLevel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblMaxLevel:SetText(_LABELS[7][LANGID]);

	search_lblClass = Turbine.UI.Label();
	search_lblClass:SetParent(search_cSearchBlockOne);
	search_lblClass:SetSize(120,20);
	search_lblClass:SetPosition(search_txtMaxLevel:GetLeft(),search_txtMaxLevel:GetTop()+search_txtMaxLevel:GetHeight()+10);
	search_lblClass:SetFont(_FONTS[1]);
	search_lblClass:SetForeColor(_COLORS[4]);
	search_lblClass:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblClass:SetText(_TABLES.ITEMINFO[14][LANGID]);

	local _ddTable = {};
	for k,v in pairs(_TABLES.CLASS) do
		table.insert(_ddTable, v[LANGID]);
	end
	table.sort(_ddTable);

	search_ddClass = Utils.DropDown(_ddTable,_TABLES.CLASS[PLAYERCLASS][LANGID]);
	search_ddClass:SetParent(search_cSearchBlockOne);
	search_ddClass:SetPosition(search_lblClass:GetLeft(),search_lblClass:GetTop()+search_lblClass:GetHeight());
	search_ddClass:SetSearchID(PLAYERCLASS);

	search_ddClass.ItemChanged = function()
		search_ddClass:SetSearchID(GetDropDownSearchID(search_ddClass,_TABLES.CLASS));
		search_ddArmourType:SetText(_TABLES.ARMORTYPE[_TABLES.ARMOURDEFAULTS[search_ddClass:GetSearchID()]][LANGID]);
	end

	search_lblArmourType = Turbine.UI.Label();
	search_lblArmourType:SetParent(search_cSearchBlockOne);
	search_lblArmourType:SetSize(120,20);
	search_lblArmourType:SetPosition(search_txtMaxLevel:GetLeft(),search_ddClass:GetTop()+search_ddClass:GetHeight()+7);
	search_lblArmourType:SetFont(_FONTS[1]);
	search_lblArmourType:SetForeColor(_COLORS[4]);
	search_lblArmourType:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblArmourType:SetText(_TABLES.ITEMINFO[7][LANGID]);

	local _ddTable = {};
	for i=1, table.getn(_TABLES.ARMORTYPE) do
		table.insert(_ddTable, _TABLES.ARMORTYPE[i][LANGID])
	end

	search_ddArmourType = Utils.DropDown(_ddTable,_TABLES.ARMORTYPE[_TABLES.ARMOURDEFAULTS[PLAYERCLASS]][LANGID]);
	search_ddArmourType:SetParent(search_cSearchBlockOne);
	search_ddArmourType:SetPosition(search_lblArmourType:GetLeft(),search_lblArmourType:GetTop()+search_lblArmourType:GetHeight());
	search_ddArmourType:SetSearchID(GetDropDownSearchID(search_ddArmourType,_TABLES.ARMORTYPE));
	search_ddArmourType:SetEnabled(false);

	search_ddArmourType.ItemChanged = function()
		search_ddArmourType:SetSearchID(GetDropDownSearchID(search_ddArmourType,_TABLES.ARMORTYPE));
	end

	search_lblWeaponType = Turbine.UI.Label();
	search_lblWeaponType:SetParent(search_cSearchBlockOne);
	search_lblWeaponType:SetSize(120,20);
	search_lblWeaponType:SetPosition(search_txtMaxLevel:GetLeft(),search_ddArmourType:GetTop()+search_ddArmourType:GetHeight()+7);
	search_lblWeaponType:SetFont(_FONTS[1]);
	search_lblWeaponType:SetForeColor(_COLORS[4]);
	search_lblWeaponType:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblWeaponType:SetText(_TABLES.SLOT[13][LANGID]);

	local _ddTable = {};
	for i=1,13 do
		table.insert(_ddTable, _TABLES.WEAPONTYPE[i][LANGID]);
	end

	search_ddWeaponType = Utils.DropDown(_ddTable,_TABLES.WEAPONTYPE[1][LANGID]);
	search_ddWeaponType:SetParent(search_cSearchBlockOne);
	search_ddWeaponType:SetPosition(search_lblWeaponType:GetLeft(),search_lblWeaponType:GetTop()+search_lblWeaponType:GetHeight());
	search_ddWeaponType:SetSearchID(GetDropDownSearchID(search_ddWeaponType,_TABLES.WEAPONTYPE));
	search_ddWeaponType:SetEnabled(false);

	search_ddWeaponType.ItemChanged = function()
		search_ddWeaponType:SetSearchID(GetDropDownSearchID(search_ddWeaponType,_TABLES.WEAPONTYPE));
	end

	search_lblRangedType = Turbine.UI.Label();
	search_lblRangedType:SetParent(search_cSearchBlockOne);
	search_lblRangedType:SetSize(120,20);
	search_lblRangedType:SetPosition(search_txtMaxLevel:GetLeft(),search_ddWeaponType:GetTop()+search_ddWeaponType:GetHeight()+7);
	search_lblRangedType:SetFont(_FONTS[1]);
	search_lblRangedType:SetForeColor(_COLORS[4]);
	search_lblRangedType:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblRangedType:SetText(_TABLES.SLOT[15][LANGID]);

	_ddTable = {};
	for i=17,21 do
		table.insert(_ddTable, _TABLES.WEAPONTYPE[i][LANGID]);
	end

	search_ddRangedType = Utils.DropDown(_ddTable);
	search_ddRangedType:SetParent(search_cSearchBlockOne);
	search_ddRangedType:SetPosition(search_lblRangedType:GetLeft(),search_lblRangedType:GetTop()+search_lblRangedType:GetHeight());
	search_ddRangedType:SetSearchID(GetDropDownSearchID(search_ddRangedType,_TABLES.WEAPONTYPE));
	search_ddRangedType:SetEnabled(false);

	search_ddRangedType.ItemChanged = function()
		search_ddRangedType:SetSearchID(GetDropDownSearchID(search_ddRangedType,_TABLES.WEAPONTYPE));
	end


	search_lblDamageType = Turbine.UI.Label();
	search_lblDamageType:SetParent(search_cSearchBlockOne);
	search_lblDamageType:SetSize(120,20);
	search_lblDamageType:SetPosition(search_txtMaxLevel:GetLeft(),search_ddRangedType:GetTop()+search_ddRangedType:GetHeight()+7);
	search_lblDamageType:SetFont(_FONTS[1]);
	search_lblDamageType:SetForeColor(_COLORS[4]);
	search_lblDamageType:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblDamageType:SetText(_TABLES.ITEMINFO[13][LANGID]);

	local _ddTable = {};
	for i=0, table.getn(_TABLES.DAMAGETYPE) do
		table.insert(_ddTable, _TABLES.DAMAGETYPE[i][LANGID])
	end

	search_ddDamageType = Utils.DropDown(_ddTable,_TABLES.DAMAGETYPE[0][LANGID]);
	search_ddDamageType:SetParent(search_cSearchBlockOne);
	search_ddDamageType:SetPosition(search_lblDamageType:GetLeft(),search_lblDamageType:GetTop()+search_lblDamageType:GetHeight());
	search_ddDamageType:SetSearchID(GetDropDownSearchID(search_ddDamageType,_TABLES.DAMAGETYPE));
	search_ddDamageType:SetEnabled(false);

	search_ddDamageType.ItemChanged = function()
		search_ddDamageType:SetSearchID(GetDropDownSearchID(search_ddDamageType,_TABLES.DAMAGETYPE));
	end

	search_lblShieldType = Turbine.UI.Label();
	search_lblShieldType:SetParent(search_cSearchBlockOne);
	search_lblShieldType:SetSize(120,20);
	search_lblShieldType:SetPosition(search_txtMaxLevel:GetLeft(),search_ddDamageType:GetTop()+search_ddDamageType:GetHeight()+7);
	search_lblShieldType:SetFont(_FONTS[1]);
	search_lblShieldType:SetForeColor(_COLORS[4]);
	search_lblShieldType:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblShieldType:SetText(_LABELS[9][LANGID]);

	local _ddTable = {};
	for i=14, 16 do -- shields only
		table.insert(_ddTable, _TABLES.WEAPONTYPE[i][LANGID])
	end

	search_ddShieldType = Utils.DropDown(_ddTable);
	search_ddShieldType:SetParent(search_cSearchBlockOne);
	search_ddShieldType:SetPosition(search_lblShieldType:GetLeft(),search_lblShieldType:GetTop()+search_lblShieldType:GetHeight());
	search_ddShieldType:SetSearchID(GetDropDownSearchID(search_ddShieldType,_TABLES.WEAPONTYPE));
	search_ddShieldType:SetEnabled(false);

	search_ddShieldType.ItemChanged = function()
		search_ddShieldType:SetSearchID(GetDropDownSearchID(search_ddShieldType,_TABLES.WEAPONTYPE));
	end


	-- Block Two -- Item Type
	search_cSearchBlockTwo = Turbine.UI.Control();
	search_cSearchBlockTwo:SetParent(search_cSearchAdvanced);
	search_cSearchBlockTwo:SetSize(190,search_cSearchAdvanced:GetHeight()-40);
	search_cSearchBlockTwo:SetPosition(search_cSearchBlockOne:GetLeft()+search_cSearchBlockOne:GetWidth()+10,30);

	search_lblItemType = Turbine.UI.Label();
	search_lblItemType:SetParent(search_cSearchBlockTwo);
	search_lblItemType:SetSize(search_cSearchBlockTwo:GetWidth(),20);
	search_lblItemType:SetPosition(0,0);
	search_lblItemType:SetFont(_FONTS[1]);
	search_lblItemType:SetForeColor(_COLORS[4]);
	search_lblItemType:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	search_lblItemType:SetText(_LABELS[8][LANGID]);

	search_lstItemsInclude = Utils.TilingBox();
	search_lstItemsInclude:SetParent(search_cSearchBlockTwo);
	search_lstItemsInclude:SetSize(search_cSearchBlockTwo:GetWidth()-10,140);
	search_lstItemsInclude:SetPosition(5,25);

	search_lstItemsExclude = Utils.TilingBox();
	search_lstItemsExclude:SetParent(search_cSearchBlockTwo);
	search_lstItemsExclude:SetSize(search_cSearchBlockTwo:GetWidth()-10,search_cSearchBlockTwo:GetHeight()-search_lstItemsInclude:GetHeight()-60);
	search_lstItemsExclude:SetPosition(5,search_cSearchBlockTwo:GetHeight()-search_lstItemsExclude:GetHeight()-5);


	-- Block Three -- Stats
	search_cSearchBlockThree = Turbine.UI.Control();
	search_cSearchBlockThree:SetParent(search_cSearchAdvanced);
	search_cSearchBlockThree:SetSize(410,search_cSearchAdvanced:GetHeight()-40);
	search_cSearchBlockThree:SetPosition(search_cSearchBlockTwo:GetLeft()+search_cSearchBlockTwo:GetWidth()+10,30);

	search_lblStats = Turbine.UI.Label();
	search_lblStats:SetParent(search_cSearchBlockThree);
	search_lblStats:SetSize(search_cSearchBlockThree:GetWidth(),20);
	search_lblStats:SetPosition(0,0);
	search_lblStats:SetFont(_FONTS[1]);
	search_lblStats:SetForeColor(_COLORS[4]);
	search_lblStats:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	search_lblStats:SetText(_TABLES.ITEMINFO[6][LANGID]);

	search_lstStatsInclude = Utils.TilingBox();
	search_lstStatsInclude:SetParent(search_cSearchBlockThree);
	search_lstStatsInclude:SetSize(search_cSearchBlockThree:GetWidth()-10,140);
	search_lstStatsInclude:SetPosition(5,25);

	search_lstStatsExclude = Utils.TilingBox();
	search_lstStatsExclude:SetParent(search_cSearchBlockThree);
	search_lstStatsExclude:SetSize(search_cSearchBlockThree:GetWidth()-10,search_cSearchBlockThree:GetHeight()-search_lstStatsInclude:GetHeight()-60);
	search_lstStatsExclude:SetPosition(5,search_cSearchBlockThree:GetHeight()-search_lstStatsExclude:GetHeight()-5);


	-- Block Four -- Quality
	search_cSearchBlockFour = Turbine.UI.Control();
	search_cSearchBlockFour:SetParent(search_cSearchAdvanced);
	search_cSearchBlockFour:SetSize(180,search_cSearchAdvanced:GetHeight()-40);
	search_cSearchBlockFour:SetPosition(search_cSearchBlockThree:GetLeft()+search_cSearchBlockThree:GetWidth()+10,30);

	search_lblQuality = Turbine.UI.Label();
	search_lblQuality:SetParent(search_cSearchBlockFour);
	search_lblQuality:SetSize(search_cSearchBlockFour:GetWidth(),20);
	search_lblQuality:SetPosition(0,0);
	search_lblQuality:SetFont(_FONTS[1]);
	search_lblQuality:SetForeColor(_COLORS[4]);
	search_lblQuality:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	search_lblQuality:SetText(_TABLES.ITEMINFO[4][LANGID]);

	search_lstQualityInclude = Utils.TilingBox();
	search_lstQualityInclude:SetParent(search_cSearchBlockFour);
	search_lstQualityInclude:SetSize(search_cSearchBlockFour:GetWidth()-10,140);
	search_lstQualityInclude:SetPosition(5,25);

	search_lstQualityExclude = Utils.TilingBox();
	search_lstQualityExclude:SetParent(search_cSearchBlockFour);
	search_lstQualityExclude:SetSize(search_cSearchBlockFour:GetWidth()-10,search_cSearchBlockFour:GetHeight()-search_lstQualityInclude:GetHeight()-60);
	search_lstQualityExclude:SetPosition(5,search_cSearchBlockFour:GetHeight()-search_lstQualityExclude:GetHeight()-5);

	-- LOAD MESSAGE ----------------------------------------------------------------------------------------------------------------------

	search_lblWelcome = Turbine.UI.Label();
	search_lblWelcome:SetParent(wSearchWin);
	search_lblWelcome:SetSize(500,200);
	search_lblWelcome:SetPosition((tempWidth/2)-(search_lblWelcome:GetWidth()/2),((tempHeight-search_cSearchPanel:GetTop()+search_cSearchPanel:GetHeight()+5)/2)-(search_lblWelcome:GetHeight()/2));
	search_lblWelcome:SetBackColor(Turbine.UI.Color(0,0,0));
	search_lblWelcome:SetFont(_FONTS[6]);
	search_lblWelcome:SetMouseVisible(false);
	search_lblWelcome:SetForeColor(_COLORS[4]);
	search_lblWelcome:SetOutlineColor(Turbine.UI.Color(0,0,0));
	search_lblWelcome:SetFontStyle(Turbine.UI.FontStyle.Outline);
	search_lblWelcome:SetMultiline(true);
	search_lblWelcome:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblWelcome:SetText(_LABELS[17][LANGID]);

	-- SEARCH RESULTS DISPLAY ------------------------------------------------------------------------------------------------------------

	search_cResultsHolder = Turbine.UI.Control();
	search_cResultsHolder:SetParent(wSearchWin);
	search_cResultsHolder:SetPosition(20,search_cSearchPanel:GetTop()+search_cSearchPanel:GetHeight()+15);
	search_cResultsHolder:SetSize(tempWidth-40,tempHeight-search_cResultsHolder:GetTop()-15);
	search_cResultsHolder:SetBackColor(Turbine.UI.Color(0,0,0));
	search_cResultsHolder:SetVisible(false);

	local listWidth = math.floor((search_cResultsHolder:GetWidth()-12)/ITEMINFOWIDTH)*ITEMINFOWIDTH;
	search_lstResults = Turbine.UI.ListBox();
	search_lstResults:SetParent(search_cResultsHolder);
	search_lstResults:SetSize(listWidth,search_cResultsHolder:GetHeight()-65);
	search_lstResults:SetPosition((search_cResultsHolder:GetWidth()/2)-(search_lstResults:GetWidth()/2)-6,25);
	search_lstResults:SetOrientation(Turbine.UI.Orientation.Horizontal);

	search_sbResults = Turbine.UI.Lotro.ScrollBar();
	search_sbResults:SetParent(search_cResultsHolder);
	search_sbResults:SetSize(11,search_lstResults:GetHeight());
	search_sbResults:SetPosition(search_lstResults:GetLeft()+search_lstResults:GetWidth()+1,search_lstResults:GetTop());
	search_sbResults:SetOrientation(Turbine.UI.Orientation.Vertical);
	search_sbResults:SetVisible(false);
	search_lstResults:SetVerticalScrollBar(search_sbResults);

	local _ddTable = {};
	for i=1, table.getn(_TABLES.SEARCHSORT) do
		table.insert(_ddTable, _TABLES.SEARCHSORT[i][LANGID])
	end

	search_ddResultSort = Utils.DropDown(_ddTable);
	search_ddResultSort:SetParent(search_cResultsHolder);
	search_ddResultSort:SetPosition((search_lstResults:GetLeft()+search_lstResults:GetWidth())-search_ddResultSort:GetWidth(),1);
	search_ddResultSort:SetSearchID(GetDropDownSearchID(search_ddResultSort,_TABLES.SEARCHSORT));

	search_ddResultSort.ItemChanged = function()
		search_ddResultSort:SetSearchID(GetDropDownSearchID(search_ddResultSort,_TABLES.SEARCHSORT));
		PrepareResults();
	end

	search_lblSort = Turbine.UI.Label();
	search_lblSort:SetParent(search_cResultsHolder);
	search_lblSort:SetSize(220,18);
	search_lblSort:SetPosition(search_ddResultSort:GetLeft()-search_lblSort:GetWidth()-7,1);
	search_lblSort:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	search_lblSort:SetFont(_FONTS[5]);
	search_lblSort:SetFontStyle(Turbine.UI.FontStyle.Outline);
	search_lblSort:SetOutlineColor(_COLORS[5]);
	search_lblSort:SetForeColor(_COLORS[4]);
	search_lblSort:SetMultiline(false);
	search_lblSort:SetText(_LABELS[15][LANGID] .. ":");

	search_lblNumResults = Turbine.UI.Label();
	search_lblNumResults:SetParent(search_cResultsHolder);
	search_lblNumResults:SetSize(400,18);
	search_lblNumResults:SetPosition(search_lstResults:GetLeft(),2);
	search_lblNumResults:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblNumResults:SetFont(_FONTS[5]);
	search_lblNumResults:SetFontStyle(Turbine.UI.FontStyle.Outline);
	search_lblNumResults:SetOutlineColor(_COLORS[5]);
	search_lblNumResults:SetForeColor(_COLORS[3]);
	search_lblNumResults:SetMultiline(false);
	search_lblNumResults:SetText("");

	-- pagenate controls
	search_backPageControls = Turbine.UI.Control();
	search_backPageControls:SetParent(search_cResultsHolder);
	search_backPageControls:SetSize(380,30);
	search_backPageControls:SetPosition((search_cResultsHolder:GetWidth()/2)-(search_backPageControls:GetWidth()/2),search_cResultsHolder:GetHeight()-search_backPageControls:GetHeight()-1);
	search_backPageControls:SetBackground(_IMAGES.BACKGROUNDS.PAGENATE);
	search_backPageControls:SetBlendMode(4);

	search_cPageHolder = Turbine.UI.Control();
	search_cPageHolder:SetParent(search_backPageControls);
	search_cPageHolder:SetSize(350,20);
	search_cPageHolder:SetPosition(15,5);

	search_cNumHolder = NewItemContainer(140,20);
	search_cNumHolder:SetParent(search_cPageHolder);
	search_cNumHolder:SetPosition((search_cPageHolder:GetWidth()/2)-(search_cNumHolder:GetWidth()/2),0);

	search_txtPageNum = NewWindowTextBox(search_cNumHolder,60,18,(search_cNumHolder:GetWidth()/2)-62,2,"");
	search_txtPageNum:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
	search_txtPageNum:SetFont(_FONTS[5]);
	RegisterEditEvent(search_txtPageNum);

	search_txtPageNum.KeyDown = function (Sender,Args)
		if Args.Action==162 then
			SEARCH_PAGE = string.gsub(search_txtPageNum:GetText(),"[%,]","");
			SEARCH_PAGE = math.floor(tonumber(SEARCH_PAGE));
			PagenateResults(SEARCH_PAGE);
		end
	end

	search_lblPageNum = Turbine.UI.Label();
	search_lblPageNum:SetParent(search_cNumHolder);
	search_lblPageNum:SetSize(60,18);
	search_lblPageNum:SetPosition((search_cNumHolder:GetWidth()/2)+2,2);
	search_lblPageNum:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	search_lblPageNum:SetFont(_FONTS[5]);
	search_lblPageNum:SetFontStyle(Turbine.UI.FontStyle.Outline);
	search_lblPageNum:SetOutlineColor(_COLORS[5]);
	search_lblPageNum:SetForeColor(_COLORS[3]);
	search_lblPageNum:SetMultiline(false);
	search_lblPageNum:SetText("");

	search_btnLast = NewPagenateButton();
	search_btnLast:SetParent(search_cPageHolder);
	search_btnLast:SetPosition(search_cPageHolder:GetWidth()-search_btnLast:GetWidth(),0);
	search_btnLast:SetText(">>");
	search_btnLast:SetToolTip(_TOOLTIPS[4][LANGID]);

	search_btnLast.Click = function ()
		SEARCH_PAGE = -1;
		PagenateResults(SEARCH_PAGE);
	end

	search_btnNext = NewPagenateButton();
	search_btnNext:SetParent(search_cPageHolder);
	search_btnNext:SetPosition(search_btnLast:GetLeft()-search_btnNext:GetWidth()-5,0);
	search_btnNext:SetText(">");
	search_btnNext:SetToolTip(_TOOLTIPS[3][LANGID]);

	search_btnNext.Click = function ()
		SEARCH_PAGE = SEARCH_PAGE + 1;
		PagenateResults(SEARCH_PAGE);
	end

	search_btnFirst = NewPagenateButton();
	search_btnFirst:SetParent(search_cPageHolder);
	search_btnFirst:SetPosition(0,0);
	search_btnFirst:SetText("<<");
	search_btnFirst:SetToolTip(_TOOLTIPS[1][LANGID]);

	search_btnFirst.Click = function ()
		SEARCH_PAGE = 1;
		PagenateResults(SEARCH_PAGE);
	end

	search_btnPrev = NewPagenateButton();
	search_btnPrev:SetParent(search_cPageHolder);
	search_btnPrev:SetPosition(search_btnFirst:GetLeft()+search_btnFirst:GetWidth()+5,0);
	search_btnPrev:SetText("<");
	search_btnPrev:SetToolTip(_TOOLTIPS[2][LANGID]);

	search_btnPrev.Click = function ()
		SEARCH_PAGE = SEARCH_PAGE - 1;
		PagenateResults(SEARCH_PAGE);
	end


	--------------------------------------------------------------------------------------------------------------------------------------

	ResetAdvancedSearch();

	-- Window Events --
	wSearchWin.PositionChanged = function()
		SETTINGS.SEARCHWIN.X = wSearchWin:GetLeft();
		SETTINGS.SEARCHWIN.Y = wSearchWin:GetTop();
	end

	wSearchWin.Closed = function ()
		HideAdvancedSearch();
	end

end


function ResetSearch()
	search_txtName:SetText(_LABELS[10][LANGID]);
	search_txtName:SetForeColor(_COLORS[2]);
	ResetAdvancedSearch();
end


function GetSearchParams()

	_SEARCHPARAMS = nil;
	_SEARCHPARAMS = {};

	-- Item Name [1]
	if search_txtName:GetText() ~= "" and search_txtName:GetText() ~= _LABELS[10][LANGID] then
		_SEARCHPARAMS[1] = search_txtName:GetText();
	end

	-- Required Level [2]
	_SEARCHPARAMS[2] = {["Min"] = 0;["Max"] = 200;};

	if search_txtMinLevel:GetText() ~= "" then
		_SEARCHPARAMS[2]["Min"] = tonumber(search_txtMinLevel:GetText());
	end

	if search_txtMaxLevel:GetText() ~= "" then
		_SEARCHPARAMS[2]["Max"] = tonumber(search_txtMaxLevel:GetText());
	end

	-- Quality [4]
	if search_lstQualityInclude:GetItemCount() > 0 then
		_SEARCHPARAMS[4] = {};
		for i=1, search_lstQualityInclude:GetItemCount() do
			_SEARCHPARAMS[4][search_lstQualityInclude:GetItem(i):GetSearchID()] = true;
		end
	end

	-- Slot [5]
	if search_lstItemsInclude:GetItemCount() > 0 then
		_SEARCHPARAMS[5] = {};
		for i=1, search_lstItemsInclude:GetItemCount() do
			_SEARCHPARAMS[5][search_lstItemsInclude:GetItem(i):GetSearchID()] = true;
		end
	end

	-- Stats [6]
	if search_lstStatsInclude:GetItemCount() > 0 then
		_SEARCHPARAMS[6] = {};
		for i=1, search_lstStatsInclude:GetItemCount() do
			_SEARCHPARAMS[6][search_lstStatsInclude:GetItem(i):GetSearchID()] = true;
		end
	end

	-- Armour Type [7]
	if search_ddArmourType:IsEnabled() == true then
		_SEARCHPARAMS[7] = search_ddArmourType:GetSearchID();
	end

	-- Weapon Type [9]
	if search_ddWeaponType:IsEnabled() or search_ddShieldType:IsEnabled() or search_ddRangedType:IsEnabled() then _SEARCHPARAMS[9] = {} end;

	if search_ddWeaponType:IsEnabled() == true then
		_SEARCHPARAMS[9][search_ddWeaponType:GetSearchID()] = true;
	end

	if search_ddRangedType:IsEnabled() == true then
		_SEARCHPARAMS[9][search_ddRangedType:GetSearchID()] = true;
	end

	if search_ddShieldType:IsEnabled() == true then
		_SEARCHPARAMS[9][search_ddShieldType:GetSearchID()] = true;
	end

	-- Damage Type [13]
	if search_ddDamageType:IsEnabled() == true then
		_SEARCHPARAMS[13] = search_ddDamageType:GetSearchID();
	end

	-- Class [14]
	_SEARCHPARAMS[14] = search_ddClass:GetSearchID();

	-- Update history table
	table.insert(_SEARCHHISTORY,1,_SEARCHPARAMS);
	_SEARCHHISTORY[11] = nil;
	RefreshSearchHistoryList();

end


function PerformSearch(savedSearch)

	if savedSearch == nil then
		GetSearchParams();
	else
		_SEARCHPARAMS = savedSearch;
	end
	HideAdvancedSearch();

	Utils.ClearTable(_SEARCHRESULTS);

	if search_btnHistory:IsEnabled() == false then search_btnHistory:SetEnabled(true) end;

	-- Loop through entire database, copy matches to _searchResults
	for k,v in pairs (_ITEMSDB) do

		local doesMatch = true; -- Assumes true until it meets a parameter that doesn't match

		-- Item name
		if _SEARCHPARAMS[1] ~= nil then
			-- Search item name and set name
			local nameMatch = false;
			if string.find(string.upper(v[1][LANGID]),string.upper(_SEARCHPARAMS[1])) or string.find(string.upper(v[1][1]),string.upper(_SEARCHPARAMS[1])) then 		-- string.upper used to remove case matching
				nameMatch = true;
			else
				if v[15] ~= nil and ( string.find(string.upper(v[15][1][LANGID]),string.upper(_SEARCHPARAMS[1])) or string.find(string.upper(v[15][1][1]),string.upper(_SEARCHPARAMS[1])) ) then
					nameMatch = true;
				end
			end
			doesMatch = nameMatch;
		end

		-- Required Level[2] and
		if doesMatch == true and _SEARCHPARAMS[2] ~= nil then
			if v[2] < _SEARCHPARAMS[2].Min or v[2] > _SEARCHPARAMS[2].Max then doesMatch = false end;
		end

		-- Quality -- multiple possibilities
		if doesMatch == true and _SEARCHPARAMS[4] ~= nil and v[4] ~= nil then
			if _SEARCHPARAMS[4][v[4]] == nil then doesMatch = false end;
		end

		-- Slot -- multiple possibilities
		if doesMatch == true and _SEARCHPARAMS[5] ~= nil and v[5] ~= nil then
			if _SEARCHPARAMS[5][v[5]] == nil then doesMatch = false end;
		end

		-- Stats -- multiple possibilities
		if doesMatch == true and _SEARCHPARAMS[6] ~= nil then
			if v[6] == nil then
				doesMatch = false;
			else
				-- loop through each to see if they match..
				for kk,vv in pairs (_SEARCHPARAMS[6]) do
					if v[6][kk] == nil then doesMatch = false end;
				end
			end
		end

		-- Armour Type
		if doesMatch == true and _SEARCHPARAMS[7] ~= nil and v[7] ~= nil then
			if v[7] ~= _SEARCHPARAMS[7] then doesMatch = false end;
		end

		-- Weapon Type -- multiple possibilities
		if doesMatch == true and _SEARCHPARAMS[9] ~= nil and v[9] ~= nil then
			-- only match when slot is a weapon
			if v[5] >= 13 and v[5] <= 16 then
				if _SEARCHPARAMS[9][v[9]] == nil then doesMatch = false end;
			end
		end

		-- Damage Type	-- all option = ID 0
		if doesMatch == true and _SEARCHPARAMS[13] ~= nil and _SEARCHPARAMS[13] ~= 0 and v[13] ~= nil then
			if v[13] ~= _SEARCHPARAMS[13] then doesMatch = false end;
		end

		-- Class
		if doesMatch == true and _SEARCHPARAMS[14] ~= nil and v[14] ~= nil then
			if v[14] ~= _SEARCHPARAMS[14] then doesMatch = false end;
		end

		if doesMatch == true then
			table.insert(_SEARCHRESULTS,k);
		end
	end

	PrepareResults();

end


function PrepareResults(_tableOveride)
	if type(_SEARCHRESULTS) ~= 'table' and _tableOveride == nil then return end;

	if wSearchWin == nil then DrawSearchWin() end;
	wSearchWin:SetVisible(true);
	wSearchWin:Activate();

	if search_lblWelcome ~= nil then
		search_cResultsHolder:SetVisible(true);
		search_lblWelcome:SetVisible(false);
		search_lblWelcome = nil;
	end

	if _tableOveride == nil then
		_SEARCHRESULTS = SortResults(_SEARCHRESULTS);
	else
		_SEARCHRESULTS = SortResults(_tableOveride);
	end

	SEARCH_PAGE = 1;
	PagenateResults();
end


function PagenateResults(pageNum)

	if pageNum == nil then pageNum = 1 end;

	search_lstResults:ClearItems();

	local numResults = table.getn(_SEARCHRESULTS);
	local maxRows = math.ceil(search_lstResults:GetHeight()/250); -- avg height
	local maxCols = math.floor(search_lstResults:GetWidth()/ITEMINFOWIDTH);
	local maxPerPage = maxRows*maxCols;
	local pages = math.ceil(numResults/maxPerPage);
	search_lstResults:SetMaxItemsPerLine(maxCols);

	if pageNum == -1 or pageNum > pages then -- used as id for last page when button is pressed
		pageNum = pages;
		SEARCH_PAGE = pageNum;
	end

	if pages == 0 then
		search_txtPageNum:SetText("0");
		search_lblPageNum:SetText("/0");
		search_lblNumResults:SetText(_LABELS[14][LANGID] .. ": 0");
	else
		search_txtPageNum:SetText(Utils.comma_value(pageNum));
		search_lblPageNum:SetText("/"..Utils.comma_value(pages));
		local first = ((pageNum-1)*maxPerPage)+1;
		local last = pageNum*maxPerPage;
		if last>numResults then last = numResults end;
		search_lblNumResults:SetText(_LABELS[14][LANGID] .. ": " .. Utils.comma_value(numResults) .. "  " .. _LABELS[75][LANGID] .. ": " .. Utils.comma_value(first).." - "..Utils.comma_value(last));
	end

	local startPage = 1 + ((pageNum-1)*maxPerPage);
	local endPage = startPage+maxPerPage-1;

	for i=startPage, endPage do
		if i>numResults then break end;
		local cItemInfo = Includes.GetItemInfoDisplay(_SEARCHRESULTS[i]);
		search_lstResults:AddItem(cItemInfo);
	end

	search_lstResults:EnsureVisible(1); -- scrolls to top

	-- Handle button states
	-- First & Prev
	if pageNum == 1 or pages == 0 then
		search_btnPrev:SetEnabled(false);
		search_btnFirst:SetEnabled(false);
	else
		search_btnPrev:SetEnabled(true);
		search_btnFirst:SetEnabled(true);
	end
	-- Next & Last
	if pageNum == pages or pages == 0 then
		search_btnNext:SetEnabled(false);
		search_btnLast:SetEnabled(false);
	else
		search_btnNext:SetEnabled(true);
		search_btnLast:SetEnabled(true);
	end
end


function SortResults(_idTable)

	if _idTable == nil then return {} end;

	local numResults = table.getn(_idTable);
	local sortID = search_ddResultSort:GetSearchID();
	local _sortedIDs = {};

	if sortID == 2 then		-- Item Name
		for i=1,numResults do
			if _ITEMSDB[_idTable[i]][1][LANGID] == nil or _ITEMSDB[_idTable[i]][1][LANGID] == "" then
				table.insert(_sortedIDs,{["id"]=_idTable[i];["val"]=_ITEMSDB[_idTable[i]][1][1];});
			else
				table.insert(_sortedIDs,{["id"]=_idTable[i];["val"]=_ITEMSDB[_idTable[i]][1][LANGID];});
			end
		end
	elseif sortID == 3 then	-- Minimum Level
		for i=1,numResults do
			table.insert(_sortedIDs,{["id"]=_idTable[i];["val"]=_ITEMSDB[_idTable[i]][2];});
		end
	elseif sortID == 4 then	-- Item Quality
		for i=1,numResults do
			table.insert(_sortedIDs,{["id"]=_idTable[i];["val"]=_ITEMSDB[_idTable[i]][4];});
		end
	else 	-- Item Slot
		for i=1,numResults do
			table.insert(_sortedIDs,{["id"]=_idTable[i];["val"]=_ITEMSDB[_idTable[i]][5];});
		end
	end

	_idTable = {};

	local sort_func = function(a,b) return a.val < b.val end;
	table.sort(_sortedIDs,sort_func);

	for k,v in ipairs(_sortedIDs) do
		table.insert(_idTable,v.id);
	end

	_sortedIDs = nil;
	return _idTable;
end


function DisplayAdvancedSearch()
	search_cSearchAdvanced:SetVisible(true);
	search_btnSimple:SetVisible(true);
	search_btnAdvanced:SetVisible(false);
	search_btnClear:SetVisible(true);
end


function HideAdvancedSearch()
	search_cSearchAdvanced:SetVisible(false);
	search_btnAdvanced:SetVisible(true);
	search_btnSimple:SetVisible(false);
	search_btnClear:SetVisible(false);
end


function GetMinSearchLevel()
	local playerLevel = PLAYERCHAR:GetLevel();
	if (playerLevel-2) < 1 then
		return 1;
	else
		return playerLevel-2;
	end
end


function GetMaxSearchLevel()
	local playerLevel = PLAYERCHAR:GetLevel();
	if (playerLevel+2) > LEVELCAP then
		return LEVELCAP;
	else
		return playerLevel+2;
	end
end


function ResetAdvancedSearch()

	search_txtMinLevel:SetText(GetMinSearchLevel());
	search_txtMaxLevel:SetText(GetMaxSearchLevel());

	search_ddClass:SetText(_TABLES.CLASS[PLAYERCLASS][LANGID]);
	search_ddClass:SetSearchID(PLAYERCLASS);

	search_ddArmourType:SetText(_TABLES.ARMORTYPE[_TABLES.ARMOURDEFAULTS[search_ddClass:GetSearchID()]][LANGID]);
	search_ddArmourType:SetSearchID(GetDropDownSearchID(search_ddArmourType,_TABLES.ARMORTYPE));
	search_ddArmourType:SetEnabled(false);

	search_ddWeaponType:SetText(_TABLES.WEAPONTYPE[1][LANGID]);
	search_ddWeaponType:SetSearchID(GetDropDownSearchID(search_ddWeaponType,_TABLES.WEAPONTYPE));
	search_ddWeaponType:SetEnabled(false);

	search_ddRangedType:SetText(_TABLES.WEAPONTYPE[17][LANGID]);
	search_ddRangedType:SetSearchID(GetDropDownSearchID(search_ddRangedType,_TABLES.WEAPONTYPE));
	search_ddRangedType:SetEnabled(false);

	search_ddDamageType:SetText(_TABLES.DAMAGETYPE[0][LANGID]);
	search_ddDamageType:SetSearchID(GetDropDownSearchID(search_ddDamageType,_TABLES.DAMAGETYPE));
	search_ddDamageType:SetEnabled(false);

	search_ddShieldType:SetText(_TABLES.WEAPONTYPE[14][LANGID]);
	search_ddShieldType:SetSearchID(GetDropDownSearchID(search_ddShieldType,_TABLES.WEAPONTYPE));
	search_ddShieldType:SetEnabled(false);

	PopulateQualityList();
	PopulateStatsList();
	PopulateItemTypeList();
end


function PopulateQualityList()

	search_lstQualityInclude:ClearItems();
	search_lstQualityExclude:ClearItems();

	for i=1, table.getn(_TABLES.QUALITY) do

		local cItemContainer,cItemLabel = NewListControl(_TABLES.QUALITY[i][LANGID]);
		cItemContainer:SetSearchID(i);
		cItemLabel:SetForeColor(_QUALITYCOLORS[i]);

		cItemContainer.MouseClick = function(Sender)
			if search_lstQualityExclude:ContainsItem(cItemContainer) then
				search_lstQualityExclude:RemoveItem(cItemContainer);
				search_lstQualityInclude:AddItem(cItemContainer);
			else
				search_lstQualityInclude:RemoveItem(cItemContainer);
				search_lstQualityExclude:AddItem(cItemContainer);
			end
		end

		search_lstQualityExclude:AddItem(cItemContainer);
	end
end


function PopulateStatsList()

	search_lstStatsInclude:ClearItems();
	search_lstStatsExclude:ClearItems();

	for i=1, table.getn(_TABLES.STATS) do

		local cItemContainer,cItemLabel = NewListControl(_TABLES.STATS[i][LANGID]);
		cItemContainer:SetSearchID(i);
		cItemLabel:SetForeColor(_COLORS[11]);

		cItemContainer.MouseClick = function(Sender)
			if search_lstStatsExclude:ContainsItem(cItemContainer) then
				search_lstStatsExclude:RemoveItem(cItemContainer);
				search_lstStatsInclude:AddItem(cItemContainer);
			else
				search_lstStatsInclude:RemoveItem(cItemContainer);
				search_lstStatsExclude:AddItem(cItemContainer);
			end
		end

		search_lstStatsExclude:AddItem(cItemContainer);
	end
end


function PopulateItemTypeList()

	search_lstItemsInclude:ClearItems();
	search_lstItemsExclude:ClearItems();

	for i=1, table.getn(_TABLES.SLOT) do

		local cItemContainer,cItemLabel = NewListControl(_TABLES.SLOT[i][LANGID]);
		cItemContainer:SetSearchID(i);
		cItemLabel:SetForeColor(_COLORS[3]);

		cItemContainer.MouseClick = function(Sender)
			if search_lstItemsExclude:ContainsItem(cItemContainer) then
				search_lstItemsExclude:RemoveItem(cItemContainer);
				search_lstItemsInclude:AddItem(cItemContainer);
			else
				search_lstItemsInclude:RemoveItem(cItemContainer);
				search_lstItemsExclude:AddItem(cItemContainer);
			end
		end

		search_lstItemsExclude:AddItem(cItemContainer);
	end

	search_lstItemsInclude.ItemAdded = function(sender,args)
		CheckItemType(args);
	end

	search_lstItemsInclude.ItemRemoved = function(sender,args)
		CheckItemType(args);
	end

end


-- This function checks items in the Item Type include box to see if it should enable any of the dropdowns
function CheckItemType(args)

	-- ITEMTYPES
	-- 6-12 = armour
	-- 13,15,16 = weapon
	-- 14 = shield

	search_ddArmourType:SetEnabled(false);
	search_ddWeaponType:SetEnabled(false);
	search_ddRangedType:SetEnabled(false);
	search_ddDamageType:SetEnabled(false);
	search_ddShieldType:SetEnabled(false)


	for i=1, search_lstItemsInclude:GetItemCount() do
		local itemType = search_lstItemsInclude:GetItem(i):GetSearchID();
		if itemType >= 6 and itemType <= 12 then search_ddArmourType:SetEnabled(true) end;
		if itemType == 13 then	-- Melee
			search_ddWeaponType:SetEnabled(true);
			search_ddDamageType:SetEnabled(true);
		end
		if itemType == 14 then search_ddShieldType:SetEnabled(true) end; -- Shield
		if itemType == 15 then -- Ranged
			search_ddRangedType:SetEnabled(true);
			search_ddDamageType:SetEnabled(true);
		end
		if itemType == 16 then	-- Rune stone
			search_ddDamageType:SetEnabled(true);
		end
	end
end

